/* 
 *   Copyright (c) 1989, 1999 by Michael J. Roberts and Steve McAdams.
 *   All Rights Reserved.
 *   
 *   Deep Space Drifter - TADS Interactive Fiction
 *
 *   10/07/2003   
 *
 *      -   RTADS   
 */

#define USE_HTML_STATUS
#define USE_HTML_PROMPT

#include <advr.t>
#include <stdr.t>
#include <errorru.t>
#include <extendr.t>
#include <gameinfo.t>
replace commonInit: function
{ "\H+";}

checkDoor: function;
checkReach: function;
itemcnt: function;
listcont: function;
listcontcont: function;
turncount: function;
addweight: function;
addbulk: function;
incscore: function;
darkTravel: function;
scoreRank: function;
terminate: function;
die: function;
init: function;
pardon: function;
preinit: function;
sleepDaemon: function;
eatDaemon: function;
shipland: function;
stopCycle: function;
suffowarn: function;
suffodo: function;
suffowarn2: function;
airLight: function;
tram2Planet: function;
tram2Hell: function;
/* tram2Station: function; */
shipDie: function;
distressCall: function;
hasMonster: function;
isTubeDest: function;
shuttleDaemon: function;
setTubeNose: function;
vacDaemon: function;
gauntletRobotFuse: function;
bombDaemon: function;
escapeDaemon: function;
exitOptions: function;
goToSleep: function;
caveDaemon: function;
stationShake: function;
dropAll: function;

getGameInfo: function
{
    return
        ['Name', '  ',
        'Byline', 'by Michael J. Roberts and Steve McAdams',
        'Desc', '      .   
                   ,      
                 ,   , , ,  
                     .
                   ,     .',
        'Version', version.vsnnum,
        'ReleaseDate', '1990-01-01',
        'LicenseType', 'Freeware',
        'CopyingRules', 'Nominal Cost Only'];
}

modify Me
  sdesc=""    
  rdesc=""
  ddesc=""
  vdesc=""
  tdesc=""
  pdesc=""
  isThem=true
  fmtYou=""
  fmtToYou=""
  fmtYour=""
  fmtYours=""
  fmtYouve="c"
  fmtWho=""
  fmtMe=""  
;

dropAll: function( actor )
{
    local cur, rem, loc, cnt;
    
    cnt := 0;
    rem := actor.contents;
    loc := actor.location;
    while ( cur := car( rem ))
    {
        if ( not cur.isworn )
	{
	    cur.moveInto( loc );
	    cnt := cnt + 1;
	}
        rem := cdr( rem );
    }
    return( cnt );
}
stationShake: function( parm )
{
  local severity;

  if ( not Me.isasleep )       // suppress explosion while dreaming
  {
    "\b";
    if ( not Me.location.isvac )
    {
        severity := rand( 10 );
        if ( severity = 1 )
            "  ,  -      . ";
        else if ( severity < 4 )
            "         
               .   ,
            - ,   . ";
        else if ( severity < 10 )
            "    ,   
             .   ,     .
                  ,    , 
                 . ";
        else
        {
            "    .  ,
                .      -,
                  .  , 
             ,     .  
                ,     , , ,
               . ";
	    
	    dropAll( Me );
        }
    }
    else
    {
        "    ,   .
           ,  -     .
         ,  . ";
    }
  }
  setfuse( stationShake, rand( 4 ) + 3, nil );  /* reset fuse in 3-7 turns */
}

replace terminate: function
{
    "\n,       !\n";
}

replace die: function
{
    "\b***   ***\b";
    scoreRank();
    exitOptions();
}

replace init: function
{
    commonInit();
    
    setscore(0, 0);
    
    "\b\b     
     . ,      
       ,        
      .
    \b,          ,
           ,  
       .         ,
       ,   ,   -,  
      .
    \b"; version.sdesc;
    "\nCopyright (c) 1988, 1990 by Michael J.\ Roberts and Steve McAdams.
     \n2003    ( 28.11.03)
    \n  .\b";

    setdaemon( turncount, nil );
    setdaemon( sleepDaemon, nil );
    setdaemon( eatDaemon, nil );
    setfuse( shipDie, 15, nil );
    setdaemon( vacDaemon, nil );
    global.sleepList := global.sleepList + vacRobot;
    startBelt.isfastened := true;
    startChair.fastenitem := startBelt;
    Me.location := startChair;
    Me.cantSleep := true;
    startChair.lookAround( true );

    setversion( '   V' + version.vsnnum );

    global.dreamList := global.dreamList + swampDream + xeniteDream;

    // set up globals
    initSearch();
}

replace preinit: function
{
    local l, o;

    l := [];
    o := firstobj(depotRoom);
    while(o <> nil)
    {
        if (o.isdepot) l := l + o;
        o := nextobj(o, depotRoom);
    }
    global.depotList := l;

    writeGameInfo(getGameInfo());
}
shipland: function( parm )
{
    "\b   . \"\", - 
      , \"    \". 
    , ,  ,  ,        .
     ,           .
    \n\t    ,    .  , 
     ,       .
    \" \", -     . ";
    startroom.isdocked := true;
    incscore( 5 );
    setfuse( stationShake, rand( 4 )+3, nil );
}
stopCycle: function( parm )
{
    if (( not stationAir.iscycled ) and cycleButton.armState = 1 )
    {
        if ( Me.location = stationAir )
            "\n\t  : \"    .
                 .\"";
        cycleButton.armState := 0;
    }
}
suffowarn: function( parm )
{
    if ( Me.location.isvac )
    {
        "\n\t";
        if ( suitTank.location = spacesuit )
        {
            ",     .
                    ,
              ? ";
        }
        else
        {
            "       , 
                    
              . , ,   .  
              . ";
        }
        setfuse( suffowarn2, 2, nil );
    }
}
suffodo: function( parm )
{
    if ( Me.location.isvac )
    {
        "\n\t    ,      
              . ";
        remdaemon( airLight, nil );
        die();
    }
}
suffowarn2: function( parm )
{
    if ( Me.location.isvac )
    {
        "\n\t     -  .
            ,        . ";
        setfuse( suffodo, 3, nil );
    }
}
airLight: function( parm )
{
    if ( Me.location.isvac )
    {
        "\n\t     ,    ,
            ";
        global.suffoCount := global.suffoCount + 1;
        if ( global.suffoCount > 4 )
            ",     . ";
        else ". ";
    }
    else remdaemon( airLight, nil );
}
tram2Planet: function( parm )
{
    local l;
    l := tramShip.launchState;
    if ( l = 2 )
        "\b   .     
              .
        \n\t       
           , , ,     
        !  ,  ,    ,    .
          ,  ,      .
               . , 
          ,    
        .   ,       
         . ";
    else if ( l = 3 )
    {
        "\b     ,     
         ,  -   .
            ,  
           . ";
        if ( Me.location.fastenitem )
        {
            " ,     , 
                   . ";
        }
        else
        {
            " ,    -  
               ,    
                   .  
               ,  ,    ,  
               . ";
            dropAll( Me );
        }
    }
    else if ( l = 4 )
        "\b   . ";
    else if ( l = 5 )
        "\b    .   . ";
    else if ( l = 6 )
    {
        "\b         . 
        ,    . ,   ,
         ,     ,  
        . ,  ,     
          ,     .
        \n\t\"    \", -    .
        \" ,  !\".\n    ,
             ,  - . ";
        tramHatch.isopen := true;
        remdaemon( tram2Planet, nil );
        global.sleepList := global.sleepList - tramShip;
        incscore( 10 );
    }
    tramShip.launchState := l + 1;
}
tram2Hell: function( parm )
{
    local s;

    s := tramShip.launchState;
    if ( s < 105 )
        "\b    . ";
    else
    {
        "\b  ,   
           ,   ,
          ,   .
         \"\"  ,    
            2000(tm),
            ,    
        .  ,      . ";
        die();
        remdaemon( tram2Hell, nil );
    }
    tramShip.launchState := s + 1;
}
/*
tram2Station: function( parm )
{
    local s;
    s := tramShip.launchState;
    if ( s = 9 )
        "\b .    . ";
    else if ( s = 10 )
        "\b     ,     . ";
    else if ( s = 11 )
        "\b      . ";
    else if ( s = 12 )
    {
        tramShip.launchState := 0;
        tramHatch.isopen := true;
        "\b       ,
           , ,  ,   .
         ,   ,  . ";
        if ( not tramShip.hasScored )
        {
            tramShip.hasScored := true;
            incscore( 3 );
        }
        remdaemon( tram2Station, nil );
    }
    if ( s <> 12 ) tramShip.launchState := s + 1;
}
*/
shipDie: function( parm )
{
    if ((( Me.location = startroom ) or ( Me.location = startChair )) and
           not ( startroom.isdocked ))
    {
        "\b      .  ,   . ";
        die();
    }
}
distressCall: function( parm )
{
    "\b     : \"
     \".    .
    ,      .\n
    , -  , -     .
          -7   
    .       ?\n ,
            .
      ;     
     . \n, -  , -
        ,   .  
           . , - 
            .\n
    -    .  ?\n   
      .   : \" 
       5381.   \". ";
    autonavButton.isready := true;
}
hasMonster: function( rm )
{
    if ( monster1.location=rm ) return( monster1 );
    if ( monster2.location=rm ) return( monster2 );
    return( nil );
}
isTubeDest: function( r )
{
    if ( r.outTubeX = shuttle.xcoord and
     r.outTubeY = shuttle.ycoord and
     r.outTubeZ = shuttle.zcoord )
    {
        shuttle.tubeDest := r;
        return( true );
    }
    else return( nil );
}
shuttleDaemon: function( parm )
{
    local x, y, thereYet, i, cnt, l, found;

    if ( shuttle.outRem>1 )       // outbound from station
    {
        if ( Me.location = shuttle ) "\b, ,   . ";
        shuttle.outRem := shuttle.outRem - 1;
    }
    else if ( shuttle.outRem=1 )  // emerging into central
    {
        shuttle.outRem := 0;
        shuttle.moveInto( centralHub );
        if ( Me.location = shuttle )
            "\b     ,
               .    
	        ,   , ,
	      ,      , 
	        . ";
    }
    else if ( shuttle.inRem>1 )   // inbound to station
    {
        if ( Me.location = shuttle ) "\b, ,   . ";
        shuttle.inRem := shuttle.inRem - 1;
    }
    else if ( shuttle.inRem=1 )   // arriving at station
    {
        shuttle.inRem := 0;

        if ( shuttle.tubeDest = tubeRubble )
        {
            setTubeNose( tubeRubble );
            if ( Me.location = shuttle )
                "\b  .  ,    
                  .    ,  
                   ,  . ";
        }
        else
        {
            shuttle.moveInto( shuttle.tubeDest );
            shuttle.isActive := nil;
            global.sleepList := global.sleepList - shuttle;
            remdaemon( shuttleDaemon, nil );
            if ( Me.location = shuttle )
            {
                "\b     .";
                if ( not canopy.isblown ) "   .";
                "\b";
                shuttle.location.enterRoom( Me );
            }
            else if ( Me.location = shuttle.location )
                "\b     . ";

            if ( shuttle.location = reactorDepot )
            {
                /*
                 *   Check for zeenite
                 */
                local c;

                c := zeenite;
                while ( c )
                {
                    if ( c = reactorDepot )
                    {
                        if ( Me.location = shuttle )
                        {
                            "    , 
                                .   , 
                            ,   -   
                             ,    . 
                                 ,
			           . ";
                            die();
                            abort;
                        }
                        else
                        {
                            "     .
                            ,    . ";
                            zeenite.timer := 0;
                            incscore( 30 );
                            setdaemon( bombDaemon, nil );
                        }
                    }
                    c := c.location;
                }
            }
        }
    }
    else                      // in central clearinghouse
    {
        if ( Me.location = shuttle )
            "\b     , ";

        thereYet := nil;      // we're not there yet by default

        if ( shuttle.autoDest )    // if on autopilot, steer
        {

            if ( shuttle.zcoord = shuttle.autoDest.outTubeZ )
            {
                /*
                 *   figure out if we're there yet
                 */
                x := shuttle.noseX;
                y := shuttle.noseY;

                // figure out if we're there by going straight ahead
                if ( shuttle.xcoord+x = shuttle.autoDest.outTubeX and
                 shuttle.ycoord+y = shuttle.autoDest.outTubeY )
                {
                    thereYet := true;
                    joystick.ycoord := joystick.xcoord := 0;
                }

                // figure out if we're there by banking right
                if (( y=1 and shuttle.ycoord=shuttle.autoDest.outTubeY
                  and shuttle.xcoord+1 = shuttle.autoDest.outTubeX ) or
                 ( y=-1 and shuttle.ycoord=shuttle.autoDest.outTubeY
                  and shuttle.xcoord-1 = shuttle.autoDest.outTubeX ) or
                 ( x=1 and shuttle.xcoord=shuttle.autoDest.outTubeX
                  and shuttle.ycoord-1 = shuttle.autoDest.outTubeY ) or
                 ( x=-1 and shuttle.xcoord=shuttle.autoDest.outTubeX
                  and shuttle.ycoord+1 = shuttle.autoDest.outTubeY ))
                {
                    thereYet := true;
                    joystick.ycoord := 0;
                    joystick.xcoord := 1;
                }
            }

            if ( not thereYet )
            {
                /*
                 *   We're not there - maneuver automatically
                 */
                if ( shuttle.zcoord > shuttle.autoDest.outTubeZ )
                    joystick.ycoord := 1;
                else if ( shuttle.zcoord < shuttle.autoDest.outTubeZ )
                    joystick.ycoord := -1;
                else joystick.ycoord := 0;

                x := shuttle.xcoord;
                y := shuttle.ycoord;

                if ( x=1 )
                {
                    if ( y=1 ) joystick.xcoord := shuttle.noseY;
                    else joystick.xcoord := shuttle.noseX;
                }
                else if ( x=2 ) joystick.xcoord := ( 2-y )*shuttle.noseY;
                else
                {
                    if ( y=3 ) joystick.xcoord := -shuttle.noseY;
                    else joystick.xcoord := -shuttle.noseX;
                }
            }
        }

        /*
         *   Now look at joystick and maneuver accordingly
         */
        if ( joystick.xcoord=1 )
        {
            if ( Me.location = shuttle ) "  , ";
            if ( shuttle.noseX )
            {
                shuttle.noseY := -shuttle.noseX;
                shuttle.noseX := 0;
            }
            else
            {
                shuttle.noseX := shuttle.noseY;
                shuttle.noseY := 0;
            }
        }
        else if ( joystick.xcoord = -1 )
        {
            if ( Me.location = shuttle ) "  , ";
            if ( shuttle.noseX )
            {
                shuttle.noseY := shuttle.noseX;
                shuttle.noseX := 0;
            }
            else
            {
                shuttle.noseX := -shuttle.noseY;
                shuttle.noseY := 0;
            }
        }

        if ( joystick.ycoord=1 and shuttle.zcoord>1 )
        {
            if ( Me.location = shuttle ) ", ";
            shuttle.zcoord := shuttle.zcoord - 1;
        }
        else if ( joystick.ycoord=-1 and shuttle.zcoord<3 )
        {
            if ( Me.location = shuttle ) ", ";
            shuttle.zcoord := shuttle.zcoord + 1;
        }

        if ( Me.location = shuttle ) "   ";

        /*
         *   We now need to say which hole we're pointing at.
         *   To make this possible, transform to wall coordinates.
         *   Wall Y (vertical) is shuttle always Z (vertical);
         *   wall X depends on the direction we're going:
         *    north ==> shuttle X
         *    south ==> 4 - (shuttle X) (invert coordinates)
         *    east  ==> 4 - (shuttle Y)
         *    west  ==> shuttle Y
         */
        y := shuttle.zcoord;           // y is easy, but...
        if ( Me.location = shuttle )
        {
            if ( x=2 and y=2 ) "";
            else
            {
                if ( x=1 ) "";
                else if ( x=2 ) "";
                else "";
                " ";
                if ( y=3 ) "";
                else if ( y=2 ) "";
                else "";
            }
            "  ";
        if ( shuttle.noseX=1 )         // travelling east
        {
            x := 4-shuttle.ycoord;     // so invert shuttle's Y
            if ( Me.location = shuttle ) "";
        }
        else if ( shuttle.noseX=-1 )   // travelling west
        {
            x := shuttle.ycoord;       // so use shuttle's Y
            if ( Me.location = shuttle ) "";
        }
        else if ( shuttle.noseY=1 )    // travelling north
        {
            x := shuttle.xcoord;       // use shuttle's X
            if ( Me.location = shuttle ) "";
        }
        else                           // travelling south
        {
            x := 4-shuttle.xcoord;     // invert shuttle's X
            if ( Me.location = shuttle ) "";
        }
        " .";
        }
        shuttle.xcoord := shuttle.xcoord + shuttle.noseX;
        shuttle.ycoord := shuttle.ycoord + shuttle.noseY;

        if ( Me.location = airvent2 )
        {
            "\b      .  
             ";
            if ( shuttle.xcoord = 1 and shuttle.ycoord = 3 )
                "  .";
            else if ( shuttle.xcoord = 1 )
            {
                if ( shuttle.ycoord = 1 ) "";
                "  .";
            }
            else if ( shuttle.ycoord = 3 )
            {
                if ( shuttle.xcoord = 3 ) "";
                "  .";
            }
            else " .";
        }

        /*
         *   Figure out if we're in a hole now - if so, go to tube mode
         */
        if ( shuttle.xcoord<1 or shuttle.xcoord>3 or
         shuttle.ycoord<1 or shuttle.ycoord>3 )
        {
            if ( Me.location = shuttle )
                " ,    . ";
            shuttle.moveInto( tubeRoom );

            /*
             *   We need to scan the list of depot rooms (those with
             *   a true isDepot property) to find out which one we're
             *   heading towards.  This list should be set up at init
             *   time.
             */
            l := global.depotList;
            cnt := length( l );
            i := 1;
            found := nil;
            while ( i <= cnt )
            {
                if (isTubeDest( l[i] ))
                {
                    found := true;
                    break;
                }
                i := i + 1;
            }
            if ( not found )
            {
                shuttle.tubeDest := tubeRubble;
                shuttle.inRem := 3;
                tubeRubble.outTubeX := shuttle.xcoord;
                tubeRubble.outTubeY := shuttle.ycoord;
                tubeRubble.outTubeZ := shuttle.zcoord;
            }
            shuttle.inRem := shuttle.tubeDest.tubeLength;
        }
    }
}
setTubeNose: function( r )
{
    local x, y, nx, ny;

    x := r.outTubeX;
    y := r.outTubeY;

    if ( x=0 )      { nx :=  1; ny :=  0; }
    else if ( x=4 ) { nx := -1; ny :=  0; }
    else if ( y=0 ) { nx :=  0; ny :=  1; }
    else            { nx :=  0; ny := -1; }

    shuttle.noseX := nx;
    shuttle.noseY := ny;

    shuttle.xcoord := x + nx;
    shuttle.ycoord := y + ny;
    shuttle.zcoord := r.outTubeZ;

    shuttle.outRem := r.tubeLength;

    shuttle.moveInto( tubeRoom );
}
vacDaemon: function( parm )
{
    local newRoom, exitDir, moveL, meLoc;

    meLoc := Me.location;
    while ( meLoc.location ) meLoc := meLoc.location;

    /*
     *   This function moves the vacRobot each turn that
     *   it's activated, and displays a message if the player
     *   is in the room that just got entered or left.
     */
    if ( not vacRobot.isActive ) return;

    vacRobot.turnsLeft := vacRobot.turnsLeft - 1;

    if ( vacRobot.turnsLeft = 0 )
    {
        /*
         *   He moves
         */
        moveL := vacRobot.moveList;
        exitDir := car( moveL );
        moveL := cdr( moveL ) + exitDir;
        newRoom := car( moveL );
        moveL := cdr( moveL ) + newRoom;
        vacRobot.moveList := moveL;

        vacRobot.turnsLeft := 3;

        if ( meLoc = vacRobot.location )
        {
            "\b   ,   ";
            say( exitDir ); ",     . ";
        }
        vacRobot.moveInto( newRoom );
        if ( meLoc = newRoom )
        {
            "\b        . ";
        }
    }
    else if ( meLoc = vacRobot.location )
        "\b    . ";
}
gauntletRobotFuse: function( parm )
{
    local meLoc;

    meLoc := Me.location;
    while ( meLoc.location ) meLoc := meLoc.location;

    gauntlet1.isActive := true;
    gauntlet1.isPowerless := nil;

    if ( meLoc = gauntlet1 )
    {
        "\b 10-    
          ,      .
               .
          ,        
	  . ";
        die();
    }
    else if ( meLoc = gauntletEntry or meLoc = gauntletDepot )
    {
        "\b ";
        if ( meLoc = gauntletEntry ) ""; else "";
        "        .
        ,      . ";
    }
}
bombDaemon: function( parm )
{
    local t;

    t := ( zeenite.timer := zeenite.timer + 1 );
    if ( t = 2 )
        "\b        . ";
    else if ( t = 4 )
        "\b     .  ,     . ";
    else if ( t = 6 )
    {
        remdaemon( bombDaemon, nil );
        "\b     ,  
         .      ,
            .\b";
        if ( Me.location = escapeShip and escapeShip.isActive )
            " ,    . ";
        else
        {
            "   . ,         . ";
            die();
        }
    }
}
escapeDaemon: function( parm )
{
    local t;

    t := ( escapeShip.timer := escapeShip.timer + 1 );
    if ( t > 1 and t < 4 )
        "\b   . ";
    else if ( t < 7 )
        "\b    . ";
    else
    {
        "\b   ,     .
	\",  \", -    , -
	 \"  ?\".
        \n\t  ,    .
          ,     - 
          ,    -
         .
        \n\t    .      , 
             .    ,
        ,         
        .   : \",    ?\",   
	      .
	 \" ,    .  ,  
	    .\"
        \n\t     ,     .  
           , - ,     .
         ,       ,    
              . \"  ,
                ,  
         !\"     ,   
         ,   ,     . \"...
         ,    ,    
        ,   ,    ,     
          .\"
        \n\t    , ,    , .
             ,      .\b";

        incscore( 15 );
        scoreRank();
        terminate();
        quit();
    }
}
exitOptions: function
{
"\b:   ,  , .\n    .\n";
    while (true)
    {
        local resp;

        "\n,  , ,   : >";
        resp := upper(input());
        resp := loweru(resp);
        if ((resp='restore') or (resp=''))
        {
            resp := askfile('  :',
                            ASKFILE_PROMPT_OPEN, FILE_TYPE_SAVE);
            if (resp = nil)
                "  . ";
            else if (restore(resp))
                "  . ";
            else
            {
                parserGetMe().location.lookAround(true);
                scoreStatus(global.score, global.turnsofar);
                ". ";
                abort;
            }
        }
        else if ((resp = 'restart') or (resp=''))
        {
            scoreStatus(0, 0);
            restart();
        }
        else if ((resp = 'exit') or (resp=''))
        {
            terminate();
            quit();
            abort;
        }
        else if ((resp = 'undo') or (resp=''))
        {
            if (undo())
            {
                "(  )\b";
                parserGetMe().location.lookAround(true);
                scoreStatus(global.score, global.turnsofar);
                abort;
            }
            else
                " ,    . ";
        }
    }

}
replace goToSleep: function
{
    local notifyList, i, cnt, dreamOk;

    /*
     *   Send a "sleeping" message to everyone in the sleeping notification
     *   list.  It is legal for objects to remove themselves from this list
     *   in the "sleeping" method.  A "true" return from "sleeping" means
     *   that the player wakes up immediately, skipping dreams.
     */
    notifyList := global.sleepList;
    i := 1;
    cnt := length( notifyList );
    dreamOk := true;
    while ( i <= cnt )
    {
        if ( notifyList[i].sleeping ) dreamOk := nil;
        i := i + 1;
    }

    if ( dreamOk )
    {
        global.awakeTime := 0;  // reset wake-up time

        /*
         *   Is there a real dream to run?  If so, run it.  If not, run a
         *   random dream.
         */
        if (car( global.dreamList ))
        {
            global.dreamList[1].runDream;
            global.dreamList := cdr( global.dreamList );
        }
        else if (car( global.randomDreamList ))
        {
            local d;

            d := global.randomDreamList[rand(length( global.randomDreamList ))];
            d.runDream;
        }
        else
        {
            "\b* * * * *
            \b    ,     . ";
        }
    }

    // 2/3 of a meal period elapses in a good night's sleep
//    global.lastMealTime := global.lastMealTime + 2*global.eatTime/3;
}
caveDaemon: function( parm )
{
    local t;

    t := global.cavetime + 1;

    if ( t = 6 )
    {
        "\b      .  , ,     . ";
    }
    else if ( t = 7 )
    {
        if ( Me.location.iscaveledge )
        {
            "\b      , 
               .  ,    ,
              . \n";
        }
        else if ( Me.location = caveLake )
	{
	    "\b  ,     
            ,   .      
              ,    ,   
            .\n";
	}
	else
        {
            "\b      ,  
            .      ,   
             .      ,
             , , ,      .\n";
            Me.travelTo( caveLake );
        }
        t := 0;
    }

    global.cavetime := t;
}

modify global
    maxscore = 200
    verbose = nil
    awakeTime = 790
    sleepTime = 800
    lastMealTime = 393
    eatTime = 400
    planetCoord = 1701
    stationCoord = 69814
    dreamList = []          // list of important dreams ("dream" objects)
    randomDreamList = []    // list of random dreams ("dream" objects)
    sleepList = []          // list of objects to notify (with "sleeping"
                            //   messages) when player sleeps
;

modify version
    sdesc = "   (Deep Space Drifter)\nRelease << self.vsnnum >>\n"
    vsnnum = '1.0'
;

vacRobot: robotItem
    location = stationMain
    moveList =
    [
        '' stationTel
        '' stationMain
        '-' stationBed2
        '' stationLav
        '' stationBed1
        '' stationMain
        '' stationDock
        '' stationMain
        '' stationKitchen
        '' stationMain
    ]
    turnsLeft = 3
    ldesc =
    {
        "  2000(tm),  .     , ";
        if (car( vacRobotSlot.contents ))
        {
            " "; car( vacRobotSlot.contents ).vdesc; ". ";
        }
        else "   . ";
        "         - . ";
        if ( vacuumCleaner.location = self.location )
            "  . ";
    }
    actorDesc =
    {
        "  ";
        if ( self.isActive )
            ",     ,   . ";
        else
            "   ,  . ";
    }
    verGrab( item ) =
    {
        if ( self.isActive )
        {
            "   ,      "; item.vdesc; ". ";
        }
    }
    sleeping =
    {
        local a, b, c;
	
	if ( self.isActive )
	{
            a := self.moveList;
            b := a[1];
            c := a[2];
            a := cdr(cdr( a ));
            self.moveList := a + b + c;
            self.moveInto( c );
            self.turnsLeft := 3;
	}
        return( nil );
    }
    isHim = true
;
startBelt: seatbeltitem
    location = startChair
    sdesc =" "
    rdesc =" "
    ddesc =" "
    vdesc =" "
    tdesc =" "
    pdesc =" "
    noun = '' '' '' '' '' '#d' '#t' '' '' '' '' '' '#d' '#t' '' '' '' '' '' '#d' '#t'
    adjective = '' '#r' '' '' '' '#d' '' '#t' ''
    isHim = true
;

startChair: chairitem
    location = startroom
    sdesc =""
    rdesc =""
    ddesc =""
    vdesc =""
    tdesc =""
    pdesc =""
    noun = '' '' '' '' '' '#d' '#t' '' '' '' '' '#d' '#t' '' '' '' '' '#d' '#t' 
    adjective = '' '#r'
    reachable = { return( self.location.contents - shipHatch ); }
    ldesc =
    {
        "  ,   ,  ,    (  ";
        if ( startBelt.isfastened )
            "";
        else
            "";
        "). ";
    }
statusPrep = ""
;
swampDream: dream
    runDream =
    {
        self.setupDream;
        "\b    ,   
          ,   
            .
        \n\t      .
           ,   
              .     ,
        ,   ,    ,
            ,  
              .\b";
        Me.travelTo( dreamSwamp1 );
    }
;
xeniteDream: dream
    runDream =
    {
        self.setupDream;
        "\b  .     
            -  ,   
        -   .   -    
        -...\b";
        Me.travelTo( dreamLab );
    }
;
startroom: room
/*
 *  This is the spaceship interior, where the player starts.
 */
    isdocked = nil
    west =
    {
        if ( shipHatch.isopen )
            return( airLock2 );
        else
        {
            " . ";
            setit( shipHatch );
            return( nil );
        }
    }
    sdesc = "<b></b>"
    first_view = true
    ldesc =
    {
        if ( self.first_view )
        {
            self.first_view := nil;
            "      ";
        }
        else if ( Me.location = startChair )
        {
            if ( Me.location.fastenitem )
            {
                "      ";
            }
            else
            {
                "      ";
            }
        }
        else
        {
            "      .
                ,      .
                  , 
                ,   ";
             if ( shipHatch.isopen ) ""; else ""; ". ";
             return;
        }
        "   .      .     ";
        if ( shipHatch.isopen )
            "";
        else
            "";
        ". ";
    }
;
stationAir: room
    sdesc = "<b> </b>"
    ldesc =
    {
        "   . ";
        if ( self.iscycled )
            "     ,     . ";
        else
            "  ,        . ";
        "        \"\". ";
    }
    iscycled = nil
    east =
    {
        if ( self.iscycled ) return( stationEva1 );
        "The door is closed. ";
        return( nil );
    }
    west =
    {
        if ( not self.iscycled ) return( stationAir1 );
        "The door is closed. ";
        return( nil );
    }
;
cycleButton: buttonitem
    location = stationAir
    sdesc =" "
    rdesc =" "
    ddesc =" "
    vdesc =" "
    tdesc =" "
    pdesc =" "
    adjective = '' '' '' '#t' '' '#r' '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
    ldesc =
    {
        ",   ,   \"\". ";
    }
    armState = 0
    doPush( actor ) =
    {
        if ( not stationAir.iscycled )
        {
            if ( self.armState = 0 )
            {
                self.armState := 1;
                "    :
                \":      . 
                      ,   
                  . \"";
                setfuse( stopCycle, 3, nil );
            }
            else if ( self.armState = 1 )
            {
                self.armState := 0;
                "     
                   .   
                ,     ,  
                 ,      .
                   . ";
                if ( not spacesuit.isworn )
                {
                    " ,      
                    .    
                      ,   , 
                         . ";
                    die();
                }
                else
                {
                    stationAir.iscycled := true;
                    stationAir.isvac := true;
                    if ( suitTank.location <> spacesuit or
                      not suitTank.isfull )
                    {
                        setfuse( suffowarn, 2, nil );
                        setdaemon( airLight, nil );
                        global.suffoCount := 0;
                    }
                    global.sleepList := global.sleepList + self;
                }
            }
        }
        else
        {
            "   .   
	        ,  
	    ;     ,    
	    . ,     ,
	       . ";
            stationAir.iscycled := nil;
            stationAir.isvac := nil;
            global.sleepList := global.sleepList - self;
            if (( not self.hasScored ) and
             ( fuse.location = tramCompartment ))
            {
                self.hasScored := true;
                incscore( 18 );
            }
        }
    }
    sleeping =
    {
        "      ,   .
         ,   ,  ,  . ";
        if ( suitTank.location = spacesuit and suitTank.isfull )
        {
            suitTank.isfull := nil;
            setfuse( suffowarn, 2 );
            setdaemon( airLight, nil );
        }
        global.sleepList := global.sleepList - self;
        global.suffoCount := 5;
        return( true );
    }
isHer=true
;
suitTank: item
    weight = 3
    bulk = 3
    location = spacesuit
    sdesc ="  "
    rdesc ="  "
    ddesc ="  "
    vdesc ="  "
    tdesc ="  "
    pdesc ="  "
    adjective = '' '' '' '#d' '' '#t' '' '' '' '' '#d' '' '#t' '' '' '#r' '2000' '2000#r'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'  ''
           '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    ldesc =
    {
        "  2000 (tm)  .    ,        .
              : ";
        if ( self.isfull )
            "\"\"";
        else
            "\"\"";
        ". ";
        if ( self.attachment )
            "   . ";
    }
    verDoAttachTo( actor, iobj ) =
    {
        if ( self.attachment )
        {
            "    "; self.vdesc; "  ";
            self.attachment.rdesc; ". ";
        }
        else if ( self.location = spacesuit )
        {
            "    ! ";
        }
    }
    doAttachTo( actor, iobj ) =
    {
        if ( iobj = airhose )
        {
            self.attachment := airhose;
            airhose.attachment := self;
           "   . ";
        }
        else if ( iobj = spacesuit )
        {
            " ,     . ";
            self.moveInto( spacesuit );
        }
        else
        {
            "     . ";
        }
    }
    verIoAttachTo( actor ) =
    {
        self.verDoAttachTo( actor, nil );
    }
    ioAttachTo( actor, dobj ) =
    {
        if ( dobj = airhose ) dobj.doAttachTo( actor, self );
        else pass ioAttachTo;
    }
    verIoPutOn( actor ) =
    {
        self.verIoAttachTo( actor );
    }
    ioPutOn( actor, dobj ) =
    {
        self.ioAttachTo( actor, dobj );
    }
    verIoTakeOff( actor ) = { self.verIoDetachFrom( actor ); }
    ioTakeOff( actor, dobj ) = { self.ioDetachFrom( actor, dobj ); }
    verIoDetachFrom( actor ) =
    {
        if ( self.attachment=nil ) "    ! ";
    }
    ioDetachFrom( actor, dobj ) =
    {
        dobj.doDetachFrom( actor, self );
    }
    verDoDetachFrom( actor, io ) =
    {
        if ( self.attachment <> io ) "    <<io.ddesc>>! ";
    }
    doDetachFrom( actor, io ) =
    {
        self.attachment.attachment := nil;
        self.attachment := nil;
        ". ";
    }
    verDoDetach( actor ) =
    {
        if ( self.attachment=nil ) "     ! ";
    }
    doDetach( actor ) =
    {
        self.doDetachFrom( actor, self.attachment );
    }
;
spacesuit: clothingItem, qcontainer
    weight = 5
    bulk = 8
    sdesc =""
    rdesc =""
    ddesc =""
    vdesc =""
    tdesc =""
    pdesc =""
    adjective = '' '#r' '' '' '' '#d' '' '#t' '' '' '' '' '#d' '' '#t' '' '2000' '2000#r' '' '' '' '' '' '#d' '#t'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d'
           '#t' '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    ldesc =
    {
        "    2000 (tm),  .      (";
        if (car( suitSocket.contents ))
        {
            "  ";
            if ( self.islighton and goodbulb.location = suitSocket )
                " "; else if (goodbulb.location = suitSocket ) " ";
            "  2000 (tm),  ";
        }
        else
            "    ";
        ")";
        if ( suitTank.location = self )
            ",   -    ";
        ",     -  . ";
    }
    doWear( actor ) =
    {
        /* make sure the actor is directly carrying me */
        if (self.location != actor)
        {
            /* try taking it */
            "( <<iao(actor)>> <<self.vdesc>>)\n";
            if (execCommand(actor, takeVerb, self) != 0)
                exit;

            /* make sure they actually were able to take me */
            if (self.location != actor)
                exit;
        }

        "  ,     .
           ,     ,
                ,
              ,    . ";
        self.isworn := true;
    }
    doUnwear( actor ) =
    {
        if ( actor.location.isvac )
        {
            "   ,    ,   
                ,     
                 . ";
            die();
        }
        else
        {
            "     2000(tm). ";
            self.isworn := nil;
        }
    }
    location = stationAir1
    verIoPutIn( actor ) = {}
    verIoAttachTo( actor ) = {}
    ioPutIn( actor, dobj ) =
    {
        if ( dobj <> suitTank )
        {
            "       . ";
        }
        else if ( dobj.location = self )
        {
            "    ! ";
        }
        else dobj.doAttachTo( actor, self );
    }
    ioAttachTo( actor, dobj ) =
    {
        self.ioPutIn( actor, dobj );
    }
    isHim = true
;
tramShip: room
    launchState = 0     // 0 ==> docked at spacestation
    hasScored = nil     // updated by daemon tram2station
    sdesc = "<b></b>"
    ldesc =
    {
        "   2000 (tm), 
             . ";
        if ( tramHatch.isopen ) ""; else "";
        "   ,    ,     .
            -   ,   -  .
           ";
        if ( tramCord.isplugged )
        {
            "     ";
            tramCord.pluggedobj.ddesc; ". ";
        }
        else "    . ";
    }
    north =
    {
        if ( tramHatch.isopen )
        {
            if ( self.launchState = 0 ) return( airLock3 );
            else return( planetLanding );
        }
        else
        {
            " . ";
            setit( tramHatch );
            return( nil );
        }
    }
    leaveRoom( actor ) =
    {
        if ( actor.isCarrying( receptacle ) and
         car( receptacle.contents ) <> nil )
            receptacle.yankPlug;
        pass leaveRoom;
    }
    sleeping =
    {
        "\b    ,         .\b";
        tramHatch.isopen := true;
        remdaemon( tram2Planet, nil );
        global.sleepList := global.sleepList - tramShip;
        return( nil );
    }
;
tramHatch: doorway
    isopen = true
    doOpen( actor ) =
    {
        "    . ";
    }
    doClose( actor ) =
    {
        self.doOpen( actor );
    }
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'

    location = tramShip
    isHim = true
;
autonavButton: buttonitem
    adjective = '' '#r' '' '#r'
    sdesc =" "
    rdesc =" "
    ddesc =" "
    vdesc =" "
    tdesc =" "
    pdesc =" "
    location = startroom
    doPush( actor ) =
    {
        if ( self.isready )
        {
            if ( self.ispushed )
               "      ,      . ";
            else
            {
                "  : \"
                .  .\"  
                ,       .
                 ,    ,  , 
                 . ";
                setfuse( shipland, 4, nil );
                self.ispushed := true;
            }
        }
        else "\".\"";
    }
    isHer = true
;
monster1: monsterItem
    adjective = '' '' '' '#t' '#d' '' '' '' '#d' '' '#t' ''
    sdesc ="    "
    rdesc ="    "
    ddesc ="    "
    vdesc ="    "
    tdesc ="    "
    pdesc ="    "
    isHer = true
;
monster2: monsterItem
    adjective = '' '' '' '#t' '#d' '' '' '' '#d' '' '#t' '' 
    sdesc ="    "
    rdesc ="    "
    ddesc ="    "
    vdesc ="    "
    tdesc ="    "
    pdesc ="    "
    isHer = true
;
shuttle: fixeditem, vehicle, container
    location = quartersDepot
    isdroploc = true    // we can drop stuff here
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '-' '-' '-' '-' '-' '-#d' '-#t'
    ldesc =
    {
        "   -,   . ";
        if ( canopy.isblown )
            "     ,      
             . ,  ,     
            (,   ?). ";
        else
            "     ,   << canopy.isopen ?
             '' : '' >>. ";
        "      . ";
    }
    inRem = 0
    outRem = 0
    doUnboard( actor ) =
    {
        if ( self.isActive )
            "        . ";
        else pass doUnboard;
    }
    out =
    {
        if ( self.isActive )
        {
            "        . ";
            return( nil );
        }
        else pass out;
    }
    // The destlist specifies which destination is reached with
    // a given autopilot setting.  The setting is contained in
    // shuttleDial.setting; the setting is merely an index into
    // this list
    destlist = [ /* escapeDepot */ quartersDepot landingDepot
      laserDepot reactorDepot ]

    sleeping =
    {
        if ( self.isActive and Me.location = self )
        {
            "     . ";
            return( true );
        }
        else
        {
            global.sleepList := global.sleepList - self;
            return( nil );
        }
    }
    isHim = true
;
centralHub: room
    sdesc = "<b> </b>"
    ldesc = "    , -  ,
      , ,      
       .       
      ,        . "
;
tubeRubble: room
    tubeLength = 3
;
canopy: fixeditem
    location = shuttle
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    adjective = '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
	   '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
    isopen = true
    ldesc =
    {
        if ( self.isblown )
            "     .
            , -   , 
                 . ";
        else " << self.isopen ? "" : "" >>. ";
    }
    isHim = true
;
reactorDepot: depotRoom
    sdesc = "<b> \"\"</b>"
    depotdesc = "   ,   .    . "
    shuttledir = ""
    east = ( self.tunneldesc )
    west = reactorControl
    outTubeX = 1
    outTubeY = 4
    outTubeZ = 1
    tubeLength = 4
;
zeenite: item
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '#d' '#t'
    ldesc = " -  .       . "
    noun = 'xenite' 'chunk'
    location = caveRoom143
    timer = 0
    doTake( actor ) =
    {
        if ( not self.hasScored )
        {
            self.hasScored := true;
            incscore( 20 );
        }
        pass doTake;
    }
    isHim = true
;
joystick: fixeditem
    location = shuttle
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
    ldesc =
    {
        "      ( ):                , , , , -,
        -, -  -.    ";
        if ( self.ycoord = 1 ) {if ( self.xcoord = 0 ) ""; else "-";}
        else if ( self.ycoord = -1 ) {if ( self.xcoord = 0 ) ""; else "-";;}
        if ( self.xcoord = 1 ) "";
        else if ( self.xcoord = -1 ) "";
        if ( self.xcoord=0 and self.ycoord=0 ) "";
        " . (  ,    :
	\"   -\"  \" \"). ";
    }
    xcoord = 0
    ycoord = 0
    verDoPush( actor ) = { "  -  \"   \"."; }
    verDoPull( actor ) = { "  -  \"   \"."; }
    verDoMoveN( actor )  = {}
    verDoMoveS( actor )  = {}
    verDoMoveE( actor )  = {}
    verDoMoveW( actor )  = {}
    verDoMoveNE( actor ) = {}
    verDoMoveNW( actor ) = {}
    verDoMoveSE( actor ) = {}
    verDoMoveSW( actor ) = {}
    verDoCenter( actor ) = {}
    genMove( x, y, n ) =
    {
        if ( autopilotSwitch.isOn )
        {
            "    .  ,   
              ,    ,
              ,       . ";
            exit;
        }
        if ( self.xcoord=x and self.ycoord=y )
        {
            "    "; say( n ); " . ";
        }
        else
        {
            ",    "; say( n ); " . ";
            self.xcoord := x;
            self.ycoord := y;
        }
    }
    doMoveN( actor )  = { self.genMove(  0,  1, '' ); }
    doMoveS( actor )  = { self.genMove(  0, -1, '' ); }
    doMoveE( actor )  = { self.genMove(  1,  0, '' ); }
    doMoveW( actor )  = { self.genMove( -1,  0, '' ); }
    doMoveNE( actor ) = { self.genMove(  1,  1, '-' ); }
    doMoveNW( actor ) = { self.genMove( -1,  1, '-' ); }
    doMoveSE( actor ) = { self.genMove(  1, -1, '-' ); }
    doMoveSW( actor ) = { self.genMove( -1, -1, '-' ); }
    doCenter( actor ) =
    {
        if ( self.xcoord=0 and self.ycoord=0 )
            "     . ";
        else
        {
            ",     . ";
            self.xcoord := self.ycoord := 0;
        }
    }
    isHim = true
;
airvent2: room
    sdesc = "<b> </b>"
    ldesc =
    {
        "       .
               ,
                  
              
         .     .  ";
        if ( shuttle.isActive and shuttle.inRem = 0 and
         shuttle.outRem = 0 )
        {
            "\n\t   . ";
	    ventshuttle.ldesc;
        }
    }
    roomAction( a, v, d, p, i ) =
    {
        if ( v = jumpVerb or v = dVerb )
        {
            if ( shuttle.isActive and shuttle.inRem = 0 and
             shuttle.outRem = 0 and shuttle.xcoord = 1 and
             shuttle.ycoord = 3 )
            {
                "     .
                 , ,  ,  
                   ! ";
                if ( canopy.isblown )
                {
                    "    ,   .\b";
                    a.travelTo( shuttle );
                    incscore( 5 );
                    exit;
                }
                else
                {
                    ", ,   .
                       ,   
                    ,      -
                       . ";
                    die();
                    abort;
                }
            }
            else
            {
                if ( v = dVerb ) pass roomAction;       // don't die on 'down'

                "    .  
                ,      . ";
                die();
                abort;
            }
        }
        else pass roomAction;
    }
    north = airvent1
;
ventshuttle: fixeditem, floatingItem
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    verIoPutIn( actor ) = { "    . "; }
    verIoPutOn( actor ) = { self.verIoPutIn( actor ); }
    verIoThrowAt( actor ) = { self.verIoPutIn( actor ); }
    locationOK = true
    location =
    {
        if ( shuttle.isActive and shuttle.inRem = 0 and
         shuttle.outRem = 0 )
        {
	    return( airvent2 );
	}
	else return( nil );
    }
    ldesc =
    {
        "   ";
        if ( shuttle.xcoord = 1 and shuttle.ycoord = 3 )
            "  .";
        else if ( shuttle.xcoord = 1 )
        {
            if ( shuttle.ycoord = 2 ) ""; else "";
            "  .";
        }
        else if ( shuttle.ycoord = 3 )
        {
            if ( shuttle.xcoord = 2 ) ""; else "";
            "  .";
        }
        else " -  .";
    }
    isHim = true
;
tubeRoom: room
    sdesc = "<b> </b>"
    ldesc = "    . "
;
gauntlet1: room
    sdesc = "<b>  </b>"
    ldesc =
    {
        "     ,     .
          ,       ; ,
              . ";
        if ( pyrRobotRemains.location = self )
            "\n\t     . ";

        "\n\t";
        if ( self.isPowerless ) // robot was just through
            "       
             ,      . 
                    ,
                 -   .
              ,      
                . ";
        else                    // disactivated via security card
            "    ,  ,   . ";
    }
    east = gauntletEntry
    west = gauntletDepot
    isActive = true
    enterRoom( actor ) =
    {
        if ( self.isActive )
        {
	    "\n\t    ,     .
	          ,  -   .
	    \n\t,  ,  -    ,
	      .   ,     
	       , -     ,
	           .
            \n\t    ,   ,
              ,   .    ,
                     .
                ,    ; 
              ,     . ";
            die();
        }
        else pass enterRoom;
    }
;
gauntletEntry: room
    sdesc = "<b> </b>"
    ldesc = "   .     ,
            . "
    east = quartersHall
    west =
    {
        if ( pyrRobot.isActive and pyrRobot.location = self )
        {
            " ,    . ";
            return( nil );
        }
        else return( gauntlet1 );
    }
;
gauntletDepot: room
    sdesc = "<b> </b>"
    ldesc =
    {
        "     ,   
         .   . ";
        if ( gauntlet1.isActive )
            "     , : \"
             -  \". ";
    }
    east = gauntlet1
;
shuttleBugNote: readable
    location = gauntletDepot
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '' '#d' '#t' '' ''
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
    ldesc = "       .  :
     \n\t\"   :    
        .     
      ,       ,
          .
      ,        
         ,     
          . , ,  
         ,  ,    
        .\" "
    isHer = true
;
escapeShip: room
    sdesc = "<b> </b>"
    ldesc =
    {
        "    . ,    
          ,      \"\". ";
        if ( self.isActive )
            " . ";
        else
            "    . ";
    }
    west =
    {
        if ( self.isActive )
        {
            " . ";
            return( nil );
        }
        else return( escapePad );
    }
    out = west
    isActive = nil
    timer = 0
;
caveLake: room
    sdesc = "<b> </b>"
    ldesc = "     (, ,  
       ).   . "
    north = caveRoom1
;
class robotItem: Actor
    weight = 1000   // way too heavy to carry
    bulk = 1000     // likewise
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    adjective = '' '' '' '#d' '' '#t' ''
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    isActive = true
    actorAction( v, d, p, i ) =
    {
        if ( self.isActive )
            " -    .
            This type of robot is generally not programmed to
            have lengthy conversations, especially with
            strangers. ";
        else
            "    ,      . ";
        exit;
    }
    verDoTurnon( actor ) =
    {
        "     . ";
    }
    verDoTurnoff( actor ) =
    {
        ",   ,   
             . ";
    }
    isHim = true
;
stationMain: room
    sdesc = "<b> </b>"
    ldesc = "     ,
            ; 
            -.
          .       ,
          -  -,   
            . "
    north = stationKitchen
    east = stationDock
    west = stationTel
    se = stationBed1
    sw = stationBed2
    up = stationCon
    down = stationComp
;
stationTel: room
    sdesc = "<b></b>"
    ldesc = "    ,     
              ,   .   
                    .
                ,   
               .    ."
    roomAction( actor, v, dobj, prep, io ) =
    {
        if ( v = eVerb and car( receptacle.contents )<>nil
         and actor.isCarrying( receptacle ))
            receptacle.yankPlug;
        pass roomAction;
    }
    east = stationMain
;
planet: fixeditem
    location = stationTel
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
    ldesc = ",           
      .       ,  . "
    isHer = true
;
stationBed2: room
    sdesc = "<b></b>"
    ldesc = "  .      , 
          - .
            . "
    north = stationMain
    ne = stationMain
    east = stationLav
;
stationLav: room
    sdesc = "<b></b>"
    ldesc =
    {
        "  .      .
             
         ,   ";
        if ( stationMedicine.isopen ) ""; else "";
        ".      . ";
    }
    east = stationBed1
    west = stationBed2
;
stationBed1: room
    sdesc = "<b></b>"
    ldesc = "  .      , 
          - .
            . "
    nw = stationMain
    north = stationMain
    west = stationLav
;
stationDock: room
    north = airLock1
    east = airLock2
    south = airLock3
    west = stationMain
    up = stationAir1
    sdesc = "<b> </b>"
    ldesc = "     .
                ,   .
                ,   . "
;
stationKitchen: room
    sdesc = "<b></b>"
    ldesc =
    {
        "  .     (";
        if ( stationMicrowave.isopen ) ""; else "";
        "),  - ";
        if ( fridge.isopen ) ""; else "";
        " ,    -   .
              . ";
    }
    south = stationMain
    roomAction( actor, v, dobj, prep, io ) =
    {
        if ( v = sVerb ) fridge.isopen := nil;
        pass roomAction;
    }
;
vacRobotSlot: tapeSlotItem
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    location = vacRobot
    isqcontainer = true
;
vacuumCleaner: item
    bulk = 2
    weight = 1
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    location = vacRobot
    ldesc =
    {
        local isOn;

        "  2000(tm),  . ";
        isOn := nil;
        if ( self.location = vacRobot or self.location = pyrRobot )
        {
            if ( self.location.isActive ) isOn := true;
        }
        if ( isOn ) " ,   . ";
        else "    .
            ,  . ";
    }
    verDoTurnon( actor ) =
    {
        "       
          ,       .
             -   . ";
    }
    isHim = true
;
seatbeltitem: fixeditem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#r' '' '' '' '#d' '' '#t' ''
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    ldesc =
    {
        "  2000(tm),   .
           ,     . ";
        if ( self.isfastened ) "  . ";
    }
    isfastened = nil
    verDoWear( actor ) = { self.verDoFasten( actor ); }
    doWear( actor ) = { self.doFasten( actor ); }
    verDoUnwear( actor ) = { self.verDoUnfasten( actor ); }
    doUnwear( actor ) = { self.doUnfasten( actor ); }
    verDoFasten( actor ) =
    {
        if ( self.isfastened ) "  ! ";
        else if ( actor.location <> self.location )
            "   . ";
    }
    doFasten( actor ) =
    {
        ", "; self.sdesc; "  . ";
        self.isfastened := true;
        self.location.fastenitem := self;
    }
    verDoUnfasten( actor ) =
    {
        if ( not self.isfastened ) "  ! ";
        else if ( actor.location <> self.location )
            "     . ";
    }
    doUnfasten( actor ) =
    {
        ", "; self.sdesc; "  . ";
        self.isfastened := nil;
        self.location.fastenitem := nil;
    }
    isHim = true
;
shipHatch: doorway
    doOpen( actor ) =
    {
        Me.cantSleep := nil;
        if ( not startroom.isdocked )
        {
            " 2000 (tm)     ,
              ,       
               .       , ,
             ,        ,
                     ,
                .";
            die();
        }
        else pass doOpen;
    }
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           
    ldesc =
    {
        ",    \" 2000(tm)\",
            .
          ";
        if ( self.isopen ) ""; else ""; ". ";
    }
    location = startroom
    isHim = true
;
dream: object
    setupDream =
    {
        Me.oldContents := Me.contents;
        Me.contents := [];
        Me.oldLocation := Me.location;
        Me.isasleep := true;
    }
    endDream =
    {
        local cur, rem;

        /*
         *   Drop all current contents into 'nil' - dream items shouldn't
         *   show up in waking world
         */
        rem := Me.contents;
        while ( cur := car( rem ))
        {
            cur.moveInto( nil );
            rem := cdr( rem );
        }

        "\b ,     . ,      .\b";
        Me.contents := Me.oldContents;
        Me.travelTo( Me.oldLocation );
        Me.isasleep := nil;
        abort;
    }
;
dreamLab: room
    sdesc = "<b></b>"
    ldesc = "     .
        - ,   . "
    east = dreamLab2
;
airLock2: room
    west = stationDock
    east = startroom
    sdesc = "<b> </b>"
    ldesc = "   .      
          .   . "
;
stationEva1: vacroom
    sdesc = "<b>  </b>"
    ldesc =
    {
        "         
         (  ). Ҹ   
          ,   . ";
        if ( goodbulb.location = suitSocket and spacesuit.islighton )
            "     ,   . ";
        else
            "     , 
                   .";
    }
    west = stationAir
    north = stationEva2
    east = stationEva3
    south = stationEva4
    roomAction( a, v, d, p, i ) =
    {
        if ( v.isTravelVerb and
         not ( goodbulb.location = suitSocket and spacesuit.islighton ))
        {
            "     ,  ,  
            ,   - .  
             ,     
             .     - 
            ,   ,    
                  ... ";
            die();
        }
        else if ( v = uVerb or v = jumpVerb )
        {
            "      ,
                . , , , 
                ,   ... ";
            die();
        }
        else pass roomAction;
    }
;
stationAir1: room
    sdesc = "<b> </b>"
    ldesc = "   .    , 
                 . "
    down = stationDock
    east = stationAir
    roomAction( actor, v, dobj, prep, io ) =
    {
        if ( v = dVerb and actor.isCarrying( spacesuit ))
        {
            "      , ";
            if ( spacesuit.isworn ) " "; else "  ";
            "    2000(tm). ";
            exit;
        }
    }
;
fuse: fuseitem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '' '' '#d' '' '#t' ''
                '' '' '' '#d' '' '#t' ''
                '' '' '' '#d' '' '#t' ''
                '' '' '' '#d' '' '#t' ''
    ldesc = "  2000(tm) -   . , 
                 .   ,    200 . "
    location = powerCompartment
;
tramCompartment: fuseCompItem
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
    adjective = '' '#r' '' '#r'
    location = tramEva
    compLabel = "  :
        \"!     \". "
;
airhose: fixeditem
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
    adjective = '' '#t' '' '' '#d' '' '#t' ''
            '' '' '' '#d' '' '#t' ''
            '' '#t' '' '#d' '#t' '' ''
            '' '#t' '' '#d' '#t' '' ''
    location = stationLab
    ldesc =
    {
        "   ,      . ";
        if ( self.attachment )
        {
            "    ";
            self.attachment.ddesc; ". ";
        }
    }
    verDoPutOn( actor, dobj ) = {}
    doPutOn( actor, dobj ) = { self.doAttachTo( actor, dobj ); }
    verIoAttachTo( actor ) = {}
    ioAttachTo( actor, dobj ) =
    {
        if ( dobj = suitTank ) dobj.doAttachTo( actor, self );
        else
        {
            "     "; dobj.vdesc; "  . ";
        }
    }
    verDoAttachTo( actor, io ) = {}
    doAttachTo( actor, io ) =
    {
        if ( io = suitTank ) io.doAttachTo( actor, self );
        else "       . ";
    }
    verIoDetachFrom( actor ) =
    {
        if ( self.attachment=nil ) "     ! ";
    }
    ioDetachFrom( actor, dobj ) =
    {
        dobj.doDetachFrom( actor, self );
    }
    verDoDetachFrom( actor, io ) =
    {
        if ( self.attachment <> io ) "<<ZAG(self,&sdsc)>>    <<io.ddesc>>! ";
    }
    doDetachFrom( actor, io ) =
    {
        if ( io = suitTank ) io.doDetachFrom( actor, self );
        else pass doDetachFrom;
    }
    verDoDetach( actor ) =
    {
        if ( self.attachment=nil ) "        ! ";
    }
    doDetach( actor ) =
    {
        self.attachment.doDetachFrom( actor, self );
    }
    verDoTake( actor ) =
    {
        if ( self.attachment ) self.verDoDetach( actor );
        else pass verDoTake;
    }
    doTake( actor ) =
    {
        if ( self.attachment ) self.doDetach( actor );
        else pass doTake;
    }
    isHim = true
;
suitSocket: socketitem
    location = spacesuit
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
;
goodbulb: bulbitem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#t' '' '#d' '#t' '' ''
                '' '#t' '' '#d' '#t' '' ''
                '' '#t' '' '#d' '#t' '' ''
                '' '#t' '' '#d' '#t' '' ''
                '' '#t' '' '#d' '#t' '' ''
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
    ldesc =
    {
        if ( self.location = fridgeSocket or
          ( self.location = suitSocket and spacesuit.islighton ))
            ",  2000(tm), , . ";
        else
            " 2000(tm)  . ";
    }
    location = fridgeSocket
    doPutIn( actor, io ) =
    {
        if ( io = fridgeSocket or io = suitSocket and spacesuit.islighton )
            " ,       . ";
        else
            ". ";
        self.moveInto( io );
    }
    isHer = true
;
tramCord: plugitem
    location = tramShip
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    isHim = true
;
airLock3: room
    north = stationDock
    south = tramShip
    sdesc = "<b> </b>"
    ldesc = "   .     
          .   . "
;
planetLanding: room
    south = tramShip
    sdesc = "<b>  </b>"
    ldesc = "     .   
       .    ,     . "
    north = landingDepot
    west = walkway
    in = tramShip
;
receptacle: fixeditem, container
    location = powerSupply
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
    ldesc =
    {
        "    . ";
        if (car( self.contents ))
        {
            "  <<iao(car( receptacle.contents ))>> "; car( receptacle.contents ).sdesc;
            ". ";
        }
        else
            "   . ";
    }
    isreceptacle = true
    verIoPlugIn( actor ) = {}
    ioPlugIn( actor, dobj ) =
    {
        self.ioPutIn( actor, dobj );
    }
    verIoPutIn( actor ) =
    {
        if (car( self.contents ))
            "      - . ";
    }
    ioPutIn( actor, dobj ) =
    {
        if ( dobj.pluggedobj )
        {
            ZAG(dobj,&sdesc); "  <<yao(dobj)>>  "; dobj.pluggedobj.vdesc; ". ";
        }
        else if ( dobj.isplug )
        {
            if ( fuse.location = powerCompartment )
            {
             if ( dobj.isShorted )
                "      
                 - ,   ";
             else
                "   , ";
            }
            if ( fuse.location <> powerCompartment ) ZAG(dobj,&sdesc);
            else dobj.sdesc;
            " <<saas(dobj)>>  . ";
            dobj.isplugged := true;
            dobj.pluggedobj := self;
            self.contents := self.contents + dobj;
            if ( dobj.isShorted and fuse.location = powerCompartment )
            {
                ",    .  
                 ,    , 
                     . ";
                powerSupply.moveInto( actor.location );
                fuse.moveInto( nil );
                meltedFuse.moveInto( powerCompartment );
            }
        }
        else
        {
            ZAG(dobj,&sdesc); "    . ";
        }
    }
    verIoTakeOut( actor ) =
    {
        self.verIoUnplugFrom( actor );
    }
    ioTakeOut( actor, dobj ) =
    {
        self.ioUnplugFrom( actor, dobj );
    }
    verIoUnplugFrom( actor ) = {}
    ioUnplugFrom( actor, dobj ) =
    {
        ZAG(dobj,sdesc); "   ";
        if ( fuse.location = powerCompartment )
         "    ";
        ". ";
        self.contents := [];
        dobj.isplugged := nil;
        dobj.pluggedobj := nil;
    }
    yankPlug =
    {
        "\n   , ";
        if ( fuse.location = powerCompartment )
            "  , ";
        " ,   ";
        car( receptacle.contents ).vdesc; "   .
        ,     !\b";
        car( receptacle.contents ).isplugged := nil;
        car( receptacle.contents ).pluggedobj := nil;
        car( receptacle.contents ).isShorted := true;
        receptacle.contents := [];
    }
    isHer = true
;
class monsterItem: fixeditem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#t' '' '#d' '#t' '' ''
                '' '#t' '' '#d' '#t' '' ''
                '' '#t' '' '#d' '#t' '' ''
                '' '#t' '' '#d' '#t' '' ''
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
    ismonster = true
;
quartersDepot: depotRoom
    sdesc = "<b> \"\"</b>"
    depotdesc = "   ,   .
           . "
    shuttledir = ""
    north = ( self.tunneldesc )
    south = quartersHall
    outTubeX = 3
    outTubeY = 0
    outTubeZ = 1
    tubeLength = 2
;
escapeDepot: depotRoom
    south = escapePad
    sdesc = "<b>   </b>"
    depotdesc = "       ,    . "
    shuttledir = ""
    west = ( self.tunneldesc )
    outTubeX = 4
    outTubeY = 2
    outTubeZ = 2
    tubeLength = 3
    ldesc =
    {
        if ( not self.isseen ) incscore( 5 );
        pass ldesc;
    }
;
landingDepot: depotRoom
    south = planetLanding
    sdesc = "<b>   </b>"
    depotdesc = "       ,    . "
    shuttledir = ""
    north = ( self.tunneldesc )
    outTubeX = 4
    outTubeY = 1
    outTubeZ = 2
    tubeLength = 3
;
laserDepot: depotRoom
    sdesc = "<b>  </b>"
    depotdesc = " ,   .    . "
    west = laserHall
    shuttledir = ""
    east = ( self.tunneldesc )
    outTubeX = 0
    outTubeY = 1
    outTubeZ = 2
    tubeLength = 3
;
class depotRoom: room
    isdepot = true
    lookAround( verbosity ) =
    {
        self.statusRoot;
	self.nrmLkAround( verbosity );
	if ( shuttle.location = self ) "\n\t   . ";
    }
    ldesc =
    {
        self.depotdesc;
        "\n\t       ,
              ;
             "; self.shuttledir ; " . ";
        if ( shuttle.location <> self ) "  . ";
    }
    tunneldesc =
    {
        "     .
             . ";
        return( nil );
    }
;
reactorControl: room
    sdesc = "<b>  </b>"
    ldesc =
    {
        "   .     .
            ";
         if ( reactorDoor.isopen ) " . ";
         else "  ,    . ";

         "\n\t    ,   
           -  .     ,
          ,   .
               ,
                ,  
               
          ,  1, 2, 3  4.";
    }
    east = reactorDepot
    down =
    {
        if ( reactorDoor.isopen ) return( reactorFloor );
        else
        {
            "  . ";
            return( nil );
        }
    }
    south = ( self.down )
;
caveRoom143: caveRoom
    down =
    {
        if ( not self.isscored )
        {
            "   , ,   ,    
             .   !       ,  ,
                 . \"  ,     
              ?  !\"  ,    ,  . 
            \"  ,    ,    ,    !
               ,    !\"
                 ,        .
            \n\t ,     . , , 
             .     . \" ...   
                  ,  .  ?
             ?  ?   ?\"    ,   
              .
            \n\t,    .    ,
               ,    .    
            ,      ,       . ";

            self.isscored := true;
            global.cavetime := 0;
            return( nil );
        }
        else return( caveRoom142 );
    }
    dirdesc = ""
    iscaveledge = true
;
autopilotSwitch: controlSwitch
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#r'
    isOn = true
    doTurnon( actor ) =
    {
        if ( actor.location = shuttle )
            " ,    , 
            \" \", . ";
        pass doTurnon;
    }
    doTurnoff( actor ) =
    {
        if ( actor.location = shuttle )
            " ,    , 
            \" \", . ";
        pass doTurnoff;
    }
    isHim = true
;
airvent1: room
    sdesc = "<b></b>"
    ldesc = "  .       . "
    north = airshaft4
    south = airvent2
;
pyrRobotRemains: fixeditem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    adjective = '' '' '' '#d' '' '#t' ''
                '' '' '' '#d' '' '#t'
                '' '#r'
    ldesc = "    2000(tm), -       ,
                    . "
;
quartersHall: room
    sdesc = "<b></b>"
    ldesc = "  ,     .    
               \"Private\"."
    north = quartersDepot
    south = quartersCommon
    west = gauntletEntry
;
pyrRobot: robotItem
    location = gauntletEntry
    actorDesc =
    {
        "    . ";
        if ( self.isActive )
            " ,    ,    .
              ,       2000(tm). ";
    }
    isActive = true
    ldesc =
    {
        "  2000(tm), -   .
            .     
         ,  ";
        if (car( pyrRobotSlot.contents ))
        {
            " "; car( pyrRobotSlot.contents ).vdesc; ". ";
        }
        else " . ";
    }
    verGrab( item ) =
    {
        if ( self.isActive )
        {
            "    ,     ";
            item.vdesc; ",      . ";
        }
    }
;
escapePad: room
    sdesc = "<b> </b>"
    ldesc =
    {
        "   .     .
              .  
          . ";
        if ( guard.location = self )
        {
            "\n\t"; ZAG(guard,&sdesc); "  . ,     . ";
        }
    }
    north = escapeDepot
    east =
    {
        if ( guard.location = self )
        {
            ZAG(guard,&sdesc); "    . ";
            return( nil );
        }
        else
            return( escapeShip );
    }
    west = swampEntry
;
caveRoom1: room
    west =
    {
        global.cavetime := global.cavetime - 1;
        return( caveRoom2 );
    }
    east =
    {
        remdaemon( caveDaemon, nil );
        global.sleepList := global.sleepList - cave1;
        return( cave1 );
    }
    south = caveLake
    sdesc = "<b></b>"
    ldesc = "  .      .
         . "
;
vacroom: room
    isvac = true
;
stationEva2: hullRoom
    litedesc = "   .    . "
    south = stationEva1
;
stationEva3: hullRoom
    litedesc = "   .       . "
    west = stationEva1
    east = shipEva
;
stationEva4: hullRoom
    litedesc = "   .      -. "
    north = stationEva1
    south = tramEva
;
class fuseitem: item
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    isfuse = true
    isHim = true
;
powerCompartment: fuseCompItem
    sdesc = "  "
    rdesc = "  "
    ddesc = "  "
    vdesc = "  "
    tdesc = "  "
    pdesc = "  "
    adjective = '' '#t' '' '#d' '#t' '' ''
                '' '#t' '' '#d' '#t' '' ''
    location = powerSupply
    compLabel = "   . "
    isHer = true
;
fuseCompItem: openable, fixeditem
    isopen = nil
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '' '' '#d' '#t'
    ldesc =
    {
        self.compLabel;
        " "; if ( self.isopen ) ", ";
        else ". ";
        if ( self.isopen )
        {
            if (car( self.contents ))
            {
                "  "; car( self.contents ).vdesc; ". ";
            }
            else " . ";
        }
    }
    ioPutIn( actor, dobj ) =
    {
        if ( dobj.isfuse ) dobj.doPutIn( actor, self );
        else
        {
            ZAG(dobj,&sdesc); "    "; self.vdesc; ". ";
        }
    }
    doOpen( actor ) =
    {
        if ( self.lockscrew )
        {
            ZAG(self.lockscrew,&sdesc); "  . ";
        }
        else pass doOpen;
    }
    isHer = true
;
tramEva: evaRoom
    sdesc = "<b> </b>"
    ldesc = "   -.
            .
            . "
    north = stationEva4
;
stationLab: room
    sdesc = "<b></b>"
    ldesc = "      .     .
           . "
    west = stationComp
    leaveRoom( actor ) =
    {
        if ( airhose.attachment )
        {
            if ( actor.isCarrying( airhose.attachment ))
            {
                " ,  "; airhose.attachment.sdesc;
                "  ,  , 
                <<iao(airhose.attachment)>> <<iao(airhose.attachment)>>
                 .
                  ,   .\b";
                airhose.attachment.attachment := nil;
                airhose.attachment := nil;
            }
        }
        if ( car( receptacle.contents )<>nil and
         actor.isCarrying( receptacle ))
            receptacle.yankPlug;
    }
;
socketitem: fixeditem, qcontainer
    ldesc =
    {
        ZAG(self,&sdesc);
        if (car( self.contents ))
        {
            "  "; car( self.contents ).sdesc; ". ";
        }
        else
        {
            " <<yao(self)>>. ";
        }
    }
    ioPutIn( actor, dobj ) =
    {
        if (car( self.contents ))
        {
            "       "; self.vdesc; ". ";
        }
        else if ( not dobj.isbulb )
        {
            ", <<dobj.sdesc>>    "; self.vdesc; ". ";
        }
        else dobj.doPutIn( actor, self );
    }
;
bulbitem: item
    isbulb = true
;
fridgeSocket: socketitem, qcontainer
    location = fridge
    sdesc = "  "
    rdesc = "  "
    ddesc = "  "
    vdesc = "  "
    tdesc = "  "
    pdesc = "  "
    adjective = '' '#r' '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
;
plugitem: fixeditem
    isplug = true
    ldesc =
    {
        "    ,
            . ";
        if ( self.isplugged )
        {
            "   "; self.pluggedobj.vdesc;". ";
        }
        if ( self.isShorted )
            "     . ,
              . ";
    }
    verDoPlugIn( actor, io ) = {}
    doPlugIn( actor, io ) =
    {
    }
    verDoUnplug( actor ) =
    {
        if ( not self.isplugged ) "   ! ";
    }
    doUnplug( actor ) =
    {
        self.pluggedobj.ioUnplugFrom( actor, self );
    }
    verDoUnplugFrom( actor, io ) =
    {
        if ( self.pluggedobj <> io )
        {
            "    "; io.vdesc; "! ";
        }
    }
;
walkway: room
    sdesc = "<b></b>"
    ldesc = "      
            ( )     . "
    east = planetLanding
    west = quartersEntry
;
powerSupply: item
    bulk = 4
    weight = 5
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#r' '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    ldesc =
    {
        "  2000(tm) -   ,   .
            ,  ,   . ";
        if (car( receptacle.contents ))
        {
            "   <<yao(car( receptacle.contents ))>> ";
            car( receptacle.contents ).sdesc; ". ";
        }
    }
    location = stationCon
    verIoPutIn( actor ) =
    {
        receptacle.verIoPutIn( actor );
    }
    ioPutIn( actor, dobj ) =
    {
        receptacle.ioPutIn( actor, dobj );
    }
    verIoPlugIn( actor ) =
    {
        receptacle.verIoPlugIn( actor );
    }
    ioPlugIn( actor, dobj ) =
    {
        receptacle.ioPlugIn( actor, dobj );
    }
    isHim = true
;
meltedFuse: fuseitem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '' '' '#d' '' '#t' ''
    ldesc = "           2000(tm). "
;
laserHall: room
    sdesc = "<b></b>"
    ldesc = "  ,     .  
       ,       . "
    east = laserDepot
    west = laserFloor1
    north = laserStorage
    south = laserControl
    up = laserControl
;
shuttleNote: readable
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '' '' '#d' '#t'
    location = laserStorage
    ldesc = "   -   :
     \n\t\"  -   - \"
     \n\t\"   -  - \"
     \n\t\" -   - \" "
    isHim = true
;
reactorFloor: room
    sdesc = "<b> </b>"
    ldesc = "     .
         ,      .
        .        , 
      ,     . "
    north = reactorTunnel
    up = reactorControl
    south = reactorFloor2
;
slagSupply: fixeditem
    sdesc = "   "
    rdesc = "   "
    ddesc = "   "
    vdesc = "   "
    tdesc = "   "
    pdesc = "   "
    adjective = '' '#r' '' '#r' '' '#r' '' '#r' '' '#r' '' '#r'
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    ldesc = "  . ,    . "
    location = reactorFloor
    isHer = true
;
caveRoom: room
    sdesc = "<b></b>"
    ldesc = "  .      << self.dirdesc >>. "
;
caveRoom142: caveRoom
    se = caveRoom140
    up = caveRoom143
    dirdesc = "-  "
;
class controlSwitch: fixeditem
    ldesc = " <<iao(self)>> << self.isOn ? "" : "" >><<yao(self)>>. "
    noun = '' '' '' '' '' '#d' '#t'
    location = controlUnit
    verDoFlip( actor ) = {}
    doFlip( actor ) =
    {
        if ( self.isOn ) self.doTurnoff( actor );
        else self.doTurnon( actor );
    }
    verDoSwitch( actor ) = {}
    doSwitch( actor ) = { self.doFlip( actor ); }
    verDoTurnon( actor ) =
    {
        if ( self.isOn ) "ZAG(self,&sdesc)  <<yao(self)>>. ";
    }
    doTurnon( actor ) =
    {
        self.isOn := true;
        ", << self.sdesc >>    \"\". ";
    }
    verDoTurnoff( actor ) =
    {
        if ( not self.isOn ) "ZAG(self,&sdesc)  <<yao(self)>>. ";
    }
    doTurnoff( actor ) =
    {
        self.isOn := nil;
        ", << self.sdesc >>    \"\". ";
    }
    isHim = true
;
stationCon: room
    sdesc = "<b> </b>"
    ldesc = "    .   ,
          ,   
          .    ,
          ,  ,   .
             . "
    down = stationMain
    roomAction( actor, v, dobj, prep, io ) =
    {
        if ( v = dVerb and car( receptacle.contents ) <> nil
         and actor.isCarrying( receptacle ))
            receptacle.yankPlug;
        pass roomAction;
    }
;
stationComp: room
    sdesc = "<b> </b>"
    ldesc = "   .     .
               ,    . "
    east = stationLab
    up = stationMain
    roomAction( actor, v, dobj, prep, io ) =
    {
        if (( v = eVerb or v = uVerb ) and
         car( receptacle.contents ) <> nil and
         actor.isCarrying( receptacle ))
            receptacle.yankPlug;
        pass roomAction;
    }
;
stationMedicine: fixeditem, openable
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '' '' '#d' '' '#t' ''
                '' '' '' '#d' '' '#t' ''
                ''
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
    isopen = nil
    location = stationLav
    ldesc =
    {
        if ( self.isopen )
        {
            if ( itemcnt( self.contents ))
            {
                "  ";
                listcont( self );
                ". ";
            }
            else " .";
        }
        else
        {
            "    ,  . ";
        }
    }
    ioPutIn( actor, dobj ) =
    {
        if ( dobj.bulk > 1 )
        {
            ZAG(dobj,&sdesc); "  <<oyay(dobj)>>. ";
        }
        else pass ioPutIn;
    }
;
airLock1: room
    south = stationDock
    north =
    {
        " , ,       ,
            . ";
        return nil;
    }
    sdesc = "<b> </b>"
    ldesc = "   .     
        ,      .
            . "
;
stationMicrowave: decoration, openable
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    adjective = '' '#t' '' '#d' '#t' '' ''
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
    location = stationKitchen
    isopen = nil
    verDoTurnon( actor ) = {}
    doTurnon( actor ) =
    {
        "  . ,   . ";
    }
    verDoTurnoff( actor ) = { "  . "; }
    isHer = true
;
fridge: openable, fixeditem
    location = stationKitchen
    isopen = nil
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    adjective = '' '' '' '#d' '' '#t' ''
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    doLookin( actor ) =
    {
        self.ldesc;
    }
    ldesc =
    {
        "  2000(tm) -      .  ";
        if ( self.isopen )
        {
            ". , -   ,   ";
            if ( goodbulb.location = fridgeSocket )
            {
                "   ";
                if (itemcnt( self.contents ))
                {
                    ""; listcont( self ); ". ";
                }
                else
                    " . ";
            }
            else
            {
                "   ";
                if (itemcnt( self.contents ))
                {
                    "  ";
                    listcont( self ); ". ";
                }
                else
                    " . ";
                if (car( fridgeSocket.contents ))
                {
                    "     
                     ";
                    car( fridgeSocket.contents ).vdesc; ". ";
                }
                else
                    "      . ";
            }
        }
        else ". ";
    }
    isHim = true
;
tapeSlotItem: fixeditem, container
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    ldesc =
    {
        if (car( self.contents ))
        {
            "  "; car( self.contents ).vdesc; ". ";
        }
        else " . ";
    }
    ioPutIn( actor, dobj ) =
    {
        if (car( self.contents ))
        {
            "    "; car( self.contents ).vdesc;
            "  "; self.rdesc; ". ";
        }
        else if ( not dobj.istape )
        {
            ZAG(dobj,&thedesc); "  <<glok(dobj,1,1)>>  "; self.vdesc; ". ";
        }
        else dobj.doPutIn( actor, self );
    }
;
quartersCommon: room
    sdesc = "<b> </b>"
    ldesc = "    .    , ,   . "
    east = quartersEntry
    north = quartersHall
    south = quartersBarracks
    west = quartersMess
;
pyrRobotSlot: tapeSlotItem
    location = pyrRobot
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
;
swampEntry: room
    west = swampG5
    sdesc = "<b></b>"
    ldesc = "      ,  .  
      . "
    east = escapePad
;
caveRoom2: caveRoom
    north = caveRoom7
    east = caveRoom1
    west = caveRoom3
    ne = caveRoom19
    dirdesc = ", ,   "
;
cave1: room
    sdesc = "<b>  </b>"
    ldesc = "   .    ,    . "
    north = basement
    west =
    {
        global.cavetime := 0;
        setdaemon( caveDaemon, nil );
        global.sleepList := global.sleepList + self;
        return( caveRoom1 );
    }
    sleeping =
    {
        if ( Me.location.iscaveledge )
        {
            "\b  ,      
            . ,      ...\b";
            return( nil );
        }
        else
        {
            "\b     ,     
              . ,  , 
                ,      .
              ,     .\b";
            Me.travelTo( caveLake );
            global.cavetime := 0;
            return( true );
        }
    }
;
hullRoom: evaRoom
    sdesc = "<b>   </b>"
    gendesc = "      . 
                  ,
             . "
    darkdesc = "  - ,     . "
;
shipEva: evaRoom
    sdesc = "<b>   </b>"
    ldesc = "      .
         ,     ,    , 
           ,     .
            . "
    west = stationEva3
;
evaRoom: vacroom
    ldesc =
    {
        self.gendesc;
        if ( goodbulb.location = suitSocket and spacesuit.islighton )
            self.litedesc;
        else
            self.darkdesc;
    }
    roomAction( actor, v, dobj, prep, io ) =
    {
        if ( v.isTravelVerb and not
         ( goodbulb.location = suitSocket and spacesuit.islighton ))
        {
            "    , ,    
            .         .
                 -     
             ,       ... ";
            die();
        }
        else if ( v = jumpVerb or v = uVerb )
        {
            " ! ,       
             .      ,    ,
                 ,    .
                .   ! ";
            die();
        }
        else pass roomAction;
    }
;
quartersEntry: room
    sdesc = "<b>   </b>"
    ldesc = "     ,   
          .    ,  
           . "
    east = walkway
    west = quartersCommon
;
class laserItem: fixeditem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#t' '' '#d' '#t' '' ''
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
    ldesc = "   ,  ,       
             .    ,    .
                . "
    isHer = true
;
laser1: laserItem
    location = laserFloor1
;
laser2: laserItem
    location = laserFloor2
;
laser3: laserItem
    location = laserFloor3
;
laser4: laserItem
    location = laserFloor4
;
laserFloor1: room
    sdesc = "<b>   </b>"
    ldesc = "    .    .
          .    
     -  -. "
    east = laserHall
    nw = laserFloor2
    sw = laserFloor3
;
laserStorage: room
    sdesc = "<b></b>"
    ldesc = "   .   . "
    south = laserHall
;
laserControl: room
    sdesc = "<b>  </b>"
    ldesc = "    .     .
        ,        
       ,   -    .
         . "
    north = laserHall
    down = laserHall
;
reactorTunnel: room
    sdesc = "<b></b>"
    ldesc = "    -. "
    north = reactorCooling
    south = reactorFloor
;
reactorFloor2: room
    sdesc = "<b> </b>"
    ldesc = "     .  
       ,    ."
    north = reactorFloor
    up = reactorCatwalk
    down = basement
    enterRoom( actor ) =
    {
        local c;

        /*
         *   Do a special containment check, to avoid allowing
         *   the zeenite to be shielded by a closed container.
         */
        c := zeenite;
        while ( c )
        {
            if ( c = self )
            {
                " ,   << zeenite.sdesc >>  .
                  ,     .
                 ,    ,   ,
                   . ,        ,
                  .  ,     
                ,   .";
                die();
                abort;
            }
            c := c.location;
        }
        pass enterRoom;
    }
;
basement: room
    sdesc = "<b></b>"
    ldesc = "  .   .
                .
           . "
    east = airshaft1
    south = cave1
    up = reactorFloor2
;
airshaft1: room
    sdesc = "<b>  </b>"
    ldesc = "     .   ,    . "
    west = basement
    up = airshaft2
;
controlUnit: item
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '' '' '#d' '' '#t' '' '' '#r' '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
    ldesc = "  -       
       .    \"\"  
      << alarmSwitch.isOn ? "\"\"" : "\"\"" >>,  ,
       \" \",   << autopilotSwitch.isOn ? "\"\"" : "\"\"" >>.
             \" \". "
    location = gauntletDepot
    doTake( actor ) =
    {
        if ( not self.hasScored )
        {
            self.hasScored := true;
            incscore( 20 );
        }
        pass doTake;
    }
    isHim = true
;
quartersBarracks: room
    sdesc = "<b></b>"
    ldesc = "   -  .   . "
    north = quartersCommon
;
biobook: readable
    sdesc = "  "
    rdesc = "  "
    ddesc = "  "
    vdesc = "  "
    tdesc = "  "
    pdesc = "  "
    adjective = '' 
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
    location = quartersBarracks
    ldesc =
    {
        "        .
         ,      ";  monster1.vdesc;
        ",    -, 
           ,  .   ,
            "; monster1.sdesc; "    
         ,       "; guard.tdesc;
          ",   .   ,   
         ,   ,   ,   
             (  ,   ). ,
         ,    "; guard.rdesc; ",-
             ,   
           .       
          ,       ,
          -      .     ";
    }
    isHer = true
;
quartersMess: room
    sdesc = "<b></b>"
    ldesc = "   . ,
               ,  . "
    east = quartersCommon
;
rations: fooditem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '' '' '#d' '' '#t'
    noun = '' '' '' '' '' '#d' '#t'
    amount = 10
    ldesc =
    {
        "       , 
               . ";
        if ( self.amount > 7 ) "  . ";
        else if ( self.amount > 4 ) "   . ";
        else if ( self.amount > 1 ) "     . ";
        else "   . ";
    }
    doEat( actor ) =
    {
        self.amount := self.amount - 1;
        global.lastMealTime := 0;
        if ( self.amount = 0 )
        {
            "   . ";
            self.moveInto( nil );
        }
        else if ( self.amount > 7 )
            "   ,   .
            There's still quite a lot left. ";
        else if ( self.amount > 4 )
            "  ,    .
                 . ";
        else if ( self.amount > 1 )
            "  .   . ";
        else
            "  . ,    
              . ";
    }
    location = quartersMess
    isThem = true
;
swampG5: swampRoom
    myplant = plantG5
    north = swampG6
    east = swampEntry
    dirdesc = ",   "
    south = swampG4
;
caveRoom7: caveRoom
    north = caveRoom8
    south = caveRoom2
    dirdesc = "  "
;
caveRoom3: caveRoom
    north = caveRoom6
    east = caveRoom2
    west = caveRoom4
    nw = caveRoom5
    dirdesc = ", ,   -"
;
caveRoom19: caveRoom
    north = caveRoom20
    ne = caveRoom18
    sw = caveRoom2
    dirdesc = ", -  -"
;
laserFloor2: room
    sdesc = "<b>   </b>"
    ldesc = "    .     -  -. "
    se = laserFloor1
    sw = laserFloor4
;
laserFloor3: room
    sdesc = "<b>   </b>"
    ldesc = "    .
         -  -. "
    ne = laserFloor1
    nw = laserFloor4
;
reactorCooling: room
    sdesc = "<b> </b>"
    ldesc = "    .
         . "
    south = reactorTunnel
;
reactorCatwalk: room
    sdesc = "<b></b>"
    ldesc = "     ,     .
       . "
    down = reactorFloor2
    north = reactorCatwalk2
;
airshaft2: room
    sdesc = "<b>  </b>"
    ldesc = "     .
          . "
    up = airshaft3
    down = airshaft1
;
alarmSwitch: controlSwitch
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#r' '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    isOn = true
    doTurnoff( actor ) =
    {
        if ( actor.location = gauntletDepot )
        {
            "       \"\",
             ,     . ";
        }
        gauntlet1.isActive := self.isOn := nil;
    }
    doTurnon( actor ) =
    {
        if ( actor.location = gauntletDepot )
        {
            "       \"\",
             ,     . ";
        }
        else if ( actor.location = gauntlet1 )
        {
            "  ,  , 
            !    ,     .
                 ,  
                   . ";
            die();
            abort;
        }
        gauntlet1.isActive := self.isOn := true;
    }
;
swampRoom: room
    isSwampRoom = true
    sdesc = "<b> </b>"
    ldesc =
    {
        "  ,  . ,      ";
        self.dirdesc; ". ";
    }
    noexit = { "     . "; return( nil ); }
    enterRoom( actor ) =
    {
        local monster;

        if ( monster := hasMonster( self ))
        {
            "      , "; monsterItem.sdesc; " <<iao(monsterItem)>> 
             ,     .  <<iao(monsterItem)>> 
                 (.., ),  <<iao(monsterItem)>>
                .      . ";
        }
        else
            pass enterRoom;
    }
    roomAction( a, v, d, p, i ) =
    {
        local monster;

        if ( v.isTravelVerb or v.issysverb ) pass roomAction;
        if ( monster := hasMonster( self ))
        {
            "    - , "; monsterItem.sdesc;
            "    <<iao(monsterItem)>>, ,   . ";
            die();
            abort;
        }
        else
            pass roomAction;
    }
    nrmLkAround( verbosity ) =
    {
        local c;

        if ( verbosity ) { "\n\t"; self.ldesc; }
        "\n\t";
        if (itemcnt( self.contents ))
        {
            "  "; listcont( self ); " . ";
        }
        listcontcont( self );
	"\n\t";
	if ( verbosity )
	{
	    "     .   
	       ,       ";
            if ( self.myplant.isPlant2 ) "  ";
            ".     ,
                . ";
	}
        if ( c := car( self.myplant.contents ))
        {
            if ( c.ismonster )
            {
                "   "; c.vdesc; " 
                 . "; ZAG(c,&thedesc); " <<glok(c,2,2)>>
                 <<ok(c,'','','','')>>   
                   . <<iao(c)>> 
                  ,     ,  
                <<iao(c)>>  <<iao(c)>>  ,  
                 <<saas(c)>>  . ";
            }
            else
            {
                "  "; c.vdesc; "   . ";
            }
        }
    }
;
plantG5: swampPlant
    location = swampG5
    myredspot = redSwampSpotG5
;
swampG6: swampRoom
    myplant = plantG6
    south = swampG5
    nw = swampF7
    dirdesc = "  -"
;
swampG4: swampRoom
    myplant = plantG4
    south = swampG3
    dirdesc = ",   "
    west = swampF4
    north = swampG5
;
laserFloor4: room
    sdesc = "<b>   </b>"
    ldesc = "     .
       .    - 
     -. "
    ne = laserFloor2
    se = laserFloor3
;
reactorCatwalk2: room
    sdesc = "<b></b>"
    ldesc = "    ,     
        . "
    north = reactorCatwalk3
    south = reactorCatwalk
;
airshaft3: room
    sdesc = "<b>  </b>"
    ldesc = "    .     . "
    up = airshaft4
    down = airshaft2
;
caveRoom8: caveRoom
    north = caveRoom10
    south = caveRoom7
    up = caveRoom9
    dirdesc = ",   "
;
caveRoom6: caveRoom
    north = caveRoom46
    south = caveRoom3
    nw = caveRoom45
    dirdesc = ",   -"
;
caveRoom4: caveRoom
    north = caveRoom5
    east = caveRoom3
    dirdesc = "  "
;
caveRoom5: caveRoom
    south = caveRoom4
    nw = caveRoom22
    se = caveRoom3
    dirdesc = ", -  -"
;
caveRoom20: caveRoom
    north = caveRoom21
    south = caveRoom19
    dirdesc = "  "
;
caveRoom18: caveRoom
    north = caveRoom17
    sw = caveRoom19
    dirdesc = "  -"
;
class swampPlant: fixeditem
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
    spotdesc = "    . "
    ldesc =
    {
        local c;

        self.spotdesc;
        c := car( self.contents );
        if ( c <> nil )
        {
            "   <<glok(c,2,2)>> "; c.sdesc; ". ";
        }
    }
    verDoLookin( actor ) = {}
    doLookin( actor ) =
    {
        local c;

        if ( c := car( self.contents ))
        {
            "  "; c.vdesc; "   . ";
        }
        else
            "     , 
              .  , -
               . ";
    }
;
redSwampSpotG5: redPlantSpot
    location = swampG5
    dirname = ""
    nextroom = escapePad
;
plantG6: swampPlant
    location = swampG6
    myredspot = redSwampSpotG6
;
swampF7: swampRoom
    myplant = plantF7
    east = swampG7
    se = swampG6
    sw = swampE6
    west = swampE7
    dirdesc = ", -, -  "
;
plantG4: swampPlant
    location = swampG4
    myredspot = redSwampSpotG4
;
swampG3: swampRoom
    myplant = plantG3
    north = swampG4
    sw = swampF2
    dirdesc = "  -"
;
swampF4: swampRoom
    myplant = plantF4
    north = swampF5
    south = swampF3
    west = swampE4
    dirdesc = ", ,   "
    east = swampG4
;
class redPlantSpot: plantSpot
    color = ""
;
redSwampSpotG6: redPlantSpot
    location = swampG6
    dirname = ""
    nextroom = swampF6
    monstroom = swampE6
;
plantF7: swampPlant2
    location = swampF7
    myredspot = redSwampSpotF7
    mybluespot = blueSwampSpotF7
;
swampG7: swampRoom
    myplant = plantG7
    west = swampF7
    dirdesc = ""
;
swampE6: swampRoom
    myplant = plantE6
    ne = swampF7
    east = swampF6
    dirdesc = ", -,   "
    south = swampE5
    west = swampD6
;
swampE7: swampRoom
    myplant = plantE7
    east = swampF7
    west = swampD7
    dirdesc = "  "
;
redSwampSpotG4: redPlantSpot
    location = swampG4
    dirname = "-"
    nextroom = escapePad
;
plantG3: swampPlant
    location = swampG3
    myredspot = redSwampSpotG3
;
swampF2: swampRoom
    myplant = plantF2
    ne = swampG3
    south = swampF1
    west = swampE2
    dirdesc = ", , -,   "
    east = swampG2
    north = swampF3
;
plantF4: swampPlant
    location = swampF4
    myredspot = redSwampSpotF4
;
swampF5: swampRoom
    myplant = plantF5
    north = swampF6
    south = swampF4
    dirdesc = "  "
;
swampF3: swampRoom
    myplant = plantF3
    north = swampF4
    dirdesc = "  "
    south = swampF2
;
swampE4: swampRoom
    myplant = plantE4
    east = swampF4
    dirdesc = ",   "
    north = swampE5
    south = swampE3
;
reactorCatwalk3: room
    sdesc = "<b></b>"
    ldesc = "     ,     .
               . "
    east = reactorCrane
    south = reactorCatwalk2
;
reactorCrane: room
    sdesc = "<b> </b>"
    ldesc = "    .
       . "
    west = reactorCatwalk3
;
class plantSpot: fixeditem
    sdesc = { self.color; " "; }
    verDoTouch( actor ) = {}
    verDoPoke( actor ) = {}
    verDoPush( actor ) = {}
    doTouch( actor ) = { self.doPush( actor ); }
    doPoke( actor ) = { self.doPush( actor ); }
    doPush( actor ) =
    {
        local ejectile, monster, omonster;

        ejectile := car( self.location.myplant.contents );
        if ( ejectile = nil )
            "    . ";
        else
        {
            if ( ejectile.isballoon )
            {
                "  "; ejectile.vdesc;
                ",  <<ejectile.itobjdesc>>   ";
                self.dirname; ". ";

                if ( self.nextroom = escapePad )
                {
		    "  ,      ";
		    ejectile.vdesc; ",  <<ejectile.itobjdesc>>  .
		       -.  , , 
		     ,   "; ejectile.sdesc; "  . 
                     ,    \"\"  -. ";
		    
                    ejectile.moveInto( plantB1 );
                }
                else
                {
                    ejectile.moveInto( self.nextroom.myplant );
                    if ( monster := hasMonster( self.nextroom ))
                    {
                        " "; ejectile.sdesc; " <<iao(ejectile)>> 
                         ,      
                        "; self.dirname; ",   
                         \"\". ";
                        if ( omonster := hasMonster( self.monstroom ))
                        {
                            omonster.moveInto( self.monstroom.myplant );
                            "  ,    
                               ,   
                             ,   \"\".  ";
                            self.dirname; "    
                            . ";
                        }
                        else
                        {
                            monster.moveInto( self.monstroom );
                        }
                    }
                    else
                    {
                        "  ,    \"\". ";
                    }
                }
            }
            else
            {
                if ( self.nextroom <> escapePad )
                {
                    /*
                     *   Internal error DSD-3021:  not connected to swamp.
                     *   Somehow, we have two monsters in the same room, but
                     *   it's not the right room.  This should be impossible,
                     *   and means that the swamp is not working correctly.
                     *   This code should come out when DSD is considered
                     *   stable [yeah, right, like that'll ever happen -Ed.].
                     */
                    "    ,  
                       (     , 
                    \"  DSD-3021\").  \", ,   \",-
                     ,  . ,    .
                    \" ,     
                     ,     .
                    (   !) ";

                    monster1.moveInto( nil );
                    monster2.moveInto( nil );
                    balloon.moveInto( nil );
                }
                else
                {
                    "    , 
                    <<ok(ejectile,'','','','')>> 
                    <<ok(ejectile,'','','','')>> "; ejectile.vdesc;
                    "   .  , <<iao(ejectile)>>
                    <<saas(ejectile)>>,   <<ella(ejectile)>>
                     .   "; guard.vdesc; ", "; monsterItem.sdesc;
                    " <<saas(ejectile)>>  .  "; guard.sdesc;
                    "   <<ejectile.ditobjdesc>> ! "; ZAG(guard,&sdesc);
                    "  ";
                    monsterItem.vdesc; "    ,     . ";
                    ejectile.moveInto( nil );
                    guard.moveInto( nil );
                    incscore( 50 );
                }
            }
        }
    }
;
guard: fixeditem
    sdesc = "  -"
    rdesc = "  -"
    ddesc = "  -"
    vdesc = "  -"
    tdesc = "  -"
    pdesc = "  -"
    adjective = '' '#t' '' '' '#d' '' '#t' ''
                '' '' '' '#d' '' '#t' ''
                ''
    noun = '-' '-' '-' '-' '-' '-#d' '-#t'
           '' '' '' '' '' '#d' '#t'
    location = escapePad
    isHim = true
;
swampF6: swampRoom
    myplant = plantF6
    south = swampF5
    west = swampE6
    dirdesc = "  "
;
class swampPlant2: swampPlant
    spotdesc = "      . "
    isPlant2 = true
;
redSwampSpotF7: redPlantSpot
    location = swampF7
    dirname = ""
    nextroom = swampG7
;
blueSwampSpotF7: bluePlantSpot
    location = swampF7
    dirname = ""
    nextroom = swampE7
    monstroom = swampD7
;
plantG7: swampPlant
    location = swampG7
    myredspot = redSwampSpotG7
;
plantE6: swampPlant
    location = swampE6
    myredspot = redSwampSpotE6
;
swampE5: swampRoom
    myplant = plantE5
    sw = swampD4
    dirdesc = ",   -"
    south = swampE4
    north = swampE6
;
swampD6: swampRoom
    myplant = plantD6
    north = swampD7
    south = swampD5
    dirdesc = ",   "
    east = swampE6
;
plantE7: swampPlant
    location = swampE7
    myredspot = redSwampSpotE7
;
swampD7: swampRoom
    myplant = plantD7
    south = swampD6
    sw = swampC6
    east = swampE7
    dirdesc = ",   -"
;
redSwampSpotG3: redPlantSpot
    location = swampG3
    dirname = ""
    nextroom = swampG4
    monstroom = swampG5
;
plantF2: swampPlant2
    location = swampF2
    myredspot = redSwampSpotF2
    mybluespot = blueSwampSpotF2
;
swampF1: swampRoom
    myplant = plantF1
    north = swampF2
    east = swampG1
    west = swampE1
    dirdesc = ",   "
;
swampE2: swampRoom
    myplant = plantE2
    north = swampE3
    east = swampF2
    dirdesc = ", ,   -"
    west = swampD2
    nw = swampD3
;
swampG2: swampRoom
    myplant = plantG2
    south = swampG1
    dirdesc = "  "
    west = swampF2
;
redSwampSpotF4: redPlantSpot
    location = swampF4
    dirname = ""
    nextroom = swampE4
    monstroom = swampD4
;
plantF5: swampPlant
    location = swampF5
    myredspot = redSwampSpotF5
;
plantF3: swampPlant
    location = swampF3
    myredspot = redSwampSpotF3
;
plantE4: swampPlant
    location = swampE4
    myredspot = redSwampSpotE4
;
swampE3: swampRoom
    myplant = plantE3
    south = swampE2
    nw = swampD4
    dirdesc = ",   -"
    north = swampE4
;
plantB1: swampPlant2
    location = swampB1
    myredspot = redSwampSpotB1
    mybluespot = blueSwampSpotB1
;
balloon: fixeditem
    isballoon = true
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    adjective = '' '' '' '#d' '' '#t' ''
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    isHim = true
;
plantF6: swampPlant2
    location = swampF6
    myredspot = redSwampSpotF6
    mybluespot = blueSwampSpotF6
;
class bluePlantSpot: plantSpot
    color = ""
;
redSwampSpotG7: redPlantSpot
    location = swampG7
    dirname = ""
    nextroom = swampG6
    monstroom = swampG5
;
redSwampSpotE6: redPlantSpot
    location = swampE6
    dirname = ""
    nextroom = swampF6
    monstroom = swampG6
;
plantE5: swampPlant
    location = swampE5
    myredspot = redSwampSpotE5
;
swampD4: swampRoom
    myplant = plantD4
    ne = swampE5
    se = swampE3
    west = swampC4
    dirdesc = "-, -  "
;
plantD6: swampPlant
    location = swampD6
    myredspot = redSwampSpotD6
;
swampD5: swampRoom
    myplant = plantD5
    north = swampD6
    west = swampC5
    dirdesc = "  "
;
redSwampSpotE7: redPlantSpot
    location = swampE7
    dirname = ""
    nextroom = swampE6
    monstroom = swampE5
;
plantD7: swampPlant
    location = swampD7
    myredspot = redSwampSpotD7
;
swampC6: swampRoom
    myplant = plantC6
    ne = swampD7
    sw = swampB5
    dirdesc = "-,   -"
    west = swampB6
;
redSwampSpotF2: redPlantSpot
    location = swampF2
    dirname = ""
    nextroom = swampF1
;
blueSwampSpotF2: bluePlantSpot
    location = swampF2
    dirname = "-"
    nextroom = swampE1
;
plantF1: swampPlant2
    location = swampF1
    myredspot = redSwampSpotF1
    mybluespot = blueSwampSpotF1
;
swampG1: swampRoom
    myplant = plantG1
    north = swampG2
    west = swampF1
    dirdesc = "  "
;
swampE1: swampRoom
    myplant = plantE1
    east = swampF1
    west = swampD1
    dirdesc = "  "
;
plantE2: swampPlant
    location = swampE2
    myredspot = redSwampSpotE2
;
swampD2: swampRoom
    myplant = plantD2
    south = swampD1
    west = swampC2
    dirdesc = ",   "
    east = swampE2
;
swampD3: swampRoom
    myplant = plantD3
    sw = swampC2
    dirdesc = "-  -"
    se = swampE2
;
plantG2: swampPlant
    location = swampG2
    myredspot = redSwampSpotG2
;
redSwampSpotF5: redPlantSpot
    location = swampF5
    dirname = "-"
    nextroom = swampE4
    monstroom = swampD3
;
redSwampSpotF3: redPlantSpot
    location = swampF3
    dirname = "-"
    nextroom = swampG2
;
redSwampSpotE4: redPlantSpot
    location = swampE4
    dirname = ""
    nextroom = swampD4
    monstroom = swampC4
;
plantE3: swampPlant2
    location = swampE3
    myredspot = redSwampSpotE3
    mybluespot = blueSwampSpotE3
;
swampB1: swampRoom
    myplant = plantB1
    north = swampB2
    ne = swampC2
    east = swampC1
    dirdesc = ",   -"
    enterRoom( actor ) =
    {
        if ( self.isseen ) pass enterRoom;

        "       ,    
          .  "; monster1.sdesc; "   ,
          .     ,   
         ,     ,"; monsterItem.sdesc; " 
          <<iao(monsterItem)>>  .  -, 
         ,   ,    .
         ,      ,  
            . "; ZAG(monster1,&sdesc);
        " <<iao(monsterItem)>>  <<iao(monsterItem)>> 
        -,   ,      
           ,   \"\".\b";

        monster1.moveInto( swampC2 );
        monster2.moveInto( swampE3 );
        balloon.moveInto( plantB1 );

        pass enterRoom;
    }
;
redSwampSpotB1: redPlantSpot
    location = swampB1
    dirname = "-"
    nextroom = swampC2
    monstroom = swampD3
;
blueSwampSpotB1: bluePlantSpot
    location = swampB1
    dirname = ""
    nextroom = swampC1
    monstroom = swampD1
;
redSwampSpotF6: redPlantSpot
    location = swampF6
    dirname = ""
    nextroom = swampF7
;
blueSwampSpotF6: bluePlantSpot
    location = swampF6
    dirname = ""
    nextroom = swampF5
    monstroom = swampF4
;
redSwampSpotE5: redPlantSpot
    location = swampE5
    dirname = ""
    nextroom = swampE4
    monstroom = swampE3
;
plantD4: swampPlant
    location = swampD4
    myredspot = redSwampSpotD4
;
swampC4: swampRoom
    myplant = plantC4
    east = swampD4
    west = swampB4
    dirdesc = ",   "
    south = swampC3
;
redSwampSpotD6: redPlantSpot
    location = swampD6
    dirname = "-"
    nextroom = swampE5
    monstroom = swampF4
;
plantD5: swampPlant
    location = swampD5
    myredspot = redSwampSpotD5
;
swampC5: swampRoom
    myplant = plantC5
    east = swampD5
    dirdesc = "  "
    west = swampB5
;
redSwampSpotD7: redPlantSpot
    location = swampD7
    dirname = ""
    nextroom = swampE7
    monstroom = swampF7
;
plantC6: swampPlant
    location = swampC6
    myredspot = redSwampSpotC6
;
swampB5: swampRoom
    myplant = plantB5
    ne = swampC6
    south = swampB4
    dirdesc = ", , -  "
    east = swampC5
    north = swampB6
;
swampB6: swampRoom
    myplant = plantB6
    ne = swampC7
    sw = swampA5
    dirdesc = "-, , ,   -"
    south = swampB5
    west = swampA6
    east = swampC6
;
redSwampSpotF1: redPlantSpot
    location = swampF1
    dirname = ""
    nextroom = swampG1
;
blueSwampSpotF1: bluePlantSpot
    location = swampF1
    dirname = ""
    nextroom = swampE1
    monstroom = swampD1
;
plantG1: swampPlant
    location = swampG1
    myredspot = redSwampSpotG1
;
plantE1: swampPlant
    location = swampE1
    myredspot = redSwampSpotE1
;
swampD1: swampRoom
    myplant = plantD1
    north = swampD2
    east = swampE1
    west = swampC1
    dirdesc = ",   "
;
redSwampSpotE2: redPlantSpot
    location = swampE2
    dirname = ""
    nextroom = swampF2
    monstroom = swampG2
;
plantD2: swampPlant2
    location = swampD2
    myredspot = redSwampSpotD2
    mybluespot = blueSwampSpotD2
;
swampC2: swampRoom
    myplant = plantC2
    north = swampC3
    ne = swampD3
    east = swampD2
    sw = swampB1
    dirdesc = ", -,   -"
;
plantD3: swampPlant2
    location = swampD3
    myredspot = redSwampSpotD3
    mybluespot = blueSwampSpotD3
;
redSwampSpotG2: redPlantSpot
    location = swampG2
    dirname = ""
    nextroom = swampG3
    monstroom = swampG4
;
redSwampSpotE3: redPlantSpot
    location = swampE3
    dirname = "-"
    nextroom = swampF4
    monstroom = swampG5
;
blueSwampSpotE3: bluePlantSpot
    location = swampE3
    dirname = ""
    nextroom = swampF3
    monstroom = swampG3
;
swampB2: swampRoom
    myplant = plantB2
    north = swampB3
    south = swampB1
    dirdesc = "  "
;
swampC1: swampRoom
    myplant = plantC1
    east = swampD1
    dirdesc = "  "
    west = swampB1
;
plantB2: swampPlant
    location = swampB2
    myredspot = redSwampSpotB2
;
swampB3: swampRoom
    myplant = plantB3
    north = swampB4
    south = swampB2
    west = swampA3
    nw = swampA4
    dirdesc = ", ,   -"
;
plantC2: swampPlant
    location = swampC2
    myredspot = redSwampSpotC2
;
swampC3: swampRoom
    myplant = plantC3
    south = swampC2
    dirdesc = "  "
    north = swampC4
;
plantC1: swampPlant
    location = swampC1
    myredspot = redSwampSpotC1
;
redSwampSpotB2: redPlantSpot
    location = swampB2
    dirname = ""
    nextroom = swampB3
    monstroom = swampB4
;
plantB3: swampPlant
    location = swampB3
    myredspot = redSwampSpotB3
;
swampB4: swampRoom
    myplant = plantB4
    north = swampB5
    east = swampC4
    south = swampB3
    dirdesc = ",   "
;
swampA3: swampRoom
    myplant = plantA3
    east = swampB3
    south = swampA2
    dirdesc = "  "
;
swampA4: swampRoom
    myplant = plantA4
    north = swampA5
    se = swampB3
    dirdesc = "  -"
;
redSwampSpotC2: redPlantSpot
    location = swampC2
    dirname = "-"
    nextroom = swampB1
;
plantC3: swampPlant2
    location = swampC3
    myredspot = redSwampSpotC3
    mybluespot = blueSwampSpotC3
;
redSwampSpotC1: redPlantSpot
    location = swampC1
    dirname = "-"
    nextroom = swampD2
    monstroom = swampE3
;
plantD1: swampPlant
    location = swampD1
    myredspot = redSwampSpotD1
;
redSwampSpotB3: redPlantSpot
    location = swampB3
    dirname = ""
    nextroom = swampB4
    monstroom = swampB5
;
plantB4: swampPlant
    location = swampB4
    myredspot = redSwampSpotB4
;
plantA3: swampPlant
    location = swampA3
    myredspot = redSwampSpotA3
;
swampA2: swampRoom
    myplant = plantA2
    north = swampA3
    south = swampA1
    dirdesc = "  "
;
plantA4: swampPlant2
    location = swampA4
    myredspot = redSwampSpotA4
    mybluespot = blueSwampSpotA4
;
swampA5: swampRoom
    myplant = plantA5
    ne = swampB6
    south = swampA4
    dirdesc = "-  "
;
redSwampSpotC3: redPlantSpot
    location = swampC3
    dirname = "-"
    nextroom = swampD2
    monstroom = swampE1
;
blueSwampSpotC3: bluePlantSpot
    location = swampC3
    dirname = "-"
    nextroom = swampB2
    monstroom = swampA1
;
plantC4: swampPlant
    location = swampC4
    myredspot = redSwampSpotC4
;
redSwampSpotD3: redPlantSpot
    location = swampD3
    dirname = "-"
    nextroom = swampE4
    monstroom = swampF5
;
blueSwampSpotD3: bluePlantSpot
    location = swampD3
    dirname = ""
    nextroom = swampE3
    monstroom = swampF3
;
redSwampSpotD2: redPlantSpot
    location = swampD2
    dirname = ""
    nextroom = swampD3
    monstroom = swampD4
;
blueSwampSpotD2: bluePlantSpot
    location = swampD2
    dirname = ""
    nextroom = swampD1
;
redSwampSpotD1: redPlantSpot
    location = swampD1
    dirname = ""
    nextroom = swampE1
    monstroom = swampF1
;
redSwampSpotD4: redPlantSpot
    location = swampD4
    dirname = ""
    nextroom = swampC4
    monstroom = swampB4
;
redSwampSpotB4: redPlantSpot
    location = swampB4
    dirname = ""
    nextroom = swampB5
    monstroom = swampB6
;
plantB5: swampPlant2
    location = swampB5
    myredspot = redSwampSpotB5
    mybluespot = blueSwampSpotB5
;
redSwampSpotA3: redPlantSpot
    location = swampA3
    dirname = ""
    nextroom = swampA2
    monstroom = swampA1
;
plantA2: swampPlant
    location = swampA2
    myredspot = redSwampSpotA2
;
swampA1: swampRoom
    myplant = plantA1
    north = swampA2
    dirdesc = ""
;
redSwampSpotA4: redPlantSpot
    location = swampA4
    dirname = "-"
    nextroom = swampB3
    monstroom = swampC2
;
blueSwampSpotA4: bluePlantSpot
    location = swampA4
    dirname = ""
    nextroom = swampA3
    monstroom = swampA2
;
plantA5: swampPlant
    location = swampA5
    myredspot = redSwampSpotA5
;
redSwampSpotC4: redPlantSpot
    location = swampC4
    dirname = ""
    nextroom = swampC3
    monstroom = swampC2
;
redSwampSpotE1: redPlantSpot
    location = swampE1
    dirname = ""
    nextroom = swampE2
    monstroom = swampE3
;
redSwampSpotB5: redPlantSpot
    location = swampB5
    dirname = "-"
    nextroom = swampA6
;
blueSwampSpotB5: bluePlantSpot
    location = swampB5
    dirname = ""
    nextroom = swampC5
    monstroom = swampD5
;
plantC5: swampPlant
    location = swampC5
    myredspot = redSwampSpotC5
;
plantB6: swampPlant
    location = swampB6
    myredspot = redSwampSpotB6
;
swampC7: swampRoom
    myplant = plantC7
    sw = swampB6
    west = swampB7
    dirdesc = "-  "
;
swampA6: swampRoom
    myplant = plantA6
    north = swampA7
    ne = swampB7
    dirdesc = ",   -"
    east = swampB6
;
redSwampSpotA2: redPlantSpot
    location = swampA2
    dirname = ""
    nextroom = swampA1
;
plantA1: swampPlant
    location = swampA1
    myredspot = redSwampSpotA1
;
redSwampSpotA5: redPlantSpot
    location = swampA5
    dirname = ""
    nextroom = swampA4
    monstroom = swampA3
;
redSwampSpotC6: redPlantSpot
    location = swampC6
    dirname = ""
    nextroom = swampC7
;
redSwampSpotC5: redPlantSpot
    location = swampC5
    dirname = ""
    nextroom = swampD5
    monstroom = swampE5
;
redSwampSpotB6: redPlantSpot
    location = swampB6
    dirname = "-"
    nextroom = swampA5
;
plantC7: swampPlant2
    location = swampC7
    myredspot = redSwampSpotC7
    mybluespot = blueSwampSpotC7
;
swampB7: swampRoom
    myplant = plantB7
    east = swampC7
    sw = swampA6
    dirdesc = "  -"
;
plantA6: swampPlant2
    location = swampA6
    myredspot = redSwampSpotA6
    mybluespot = blueSwampSpotA6
;
swampA7: swampRoom
    myplant = plantA7
    south = swampA6
    dirdesc = ""
;
redSwampSpotA1: redPlantSpot
    location = swampA1
    dirname = ""
    nextroom = swampB1
    monstroom = swampC1
;
redSwampSpotG1: redPlantSpot
    location = swampG1
    dirname = ""
    nextroom = swampG2
    monstroom = swampG3
;
/*
pyramidBack: room
    sdesc = "<b> </b>"
    ldesc = "    .     .
         ,     -  . "
    up = planetHill
    nw = planetHill
    west = gauntletEntry
;
planetHill: room
    sdesc = "<b> </b>"
    ldesc = "   ,      .
            ,   
             4.    
        ,    .    
         -,   -. "
    se = pyramidBack
    sw = pyramidFront
    west = planetTrail
    down =
    {
        "     .  
        ,   . ";
        return( nil );
    }
;
pyramidFront: room
    sdesc = "<b> </b>"
    ldesc = "   .     ()
        ,    .  
            ,    - .  "
    ne = planetHill
    up = planetHill
    west = planetLanding
;
planetTrail: room
    north = swampEntry
    sdesc = "<b> "</b>
    ldesc = "     . 
            .     ,
        ,  ,  ,      . "
    south = planetLanding
    east = planetHill
    up = planetHill
;
*/
redSwampSpotD5: redPlantSpot
    location = swampD5
    dirname = ""
    nextroom = swampD6
    monstroom = swampD7
;
redSwampSpotC7: redPlantSpot
    location = swampC7
    dirname = ""
    nextroom = swampD7
    monstroom = swampE7
;
blueSwampSpotC7: bluePlantSpot
    location = swampC7
    dirname = ""
    nextroom = swampC6
    monstroom = swampC5
;
plantB7: swampPlant
    location = swampB7
    myredspot = redSwampSpotB7
;
redSwampSpotA6: redPlantSpot
    location = swampA6
    dirname = ""
    nextroom = swampA7
;
blueSwampSpotA6: bluePlantSpot
    location = swampA6
    dirname = "-"
    nextroom = swampB7
;
plantA7: swampPlant2
    location = swampA7
    myredspot = redSwampSpotA7
    mybluespot = blueSwampSpotA7
;
redSwampSpotB7: redPlantSpot
    location = swampB7
    dirname = ""
    nextroom = swampC7
    monstroom = swampD7
;
redSwampSpotA7: redPlantSpot
    location = swampA7
    dirname = ""
    nextroom = swampB7
    monstroom = swampC7
;
blueSwampSpotA7: bluePlantSpot
    location = swampA7
    dirname = "-"
    nextroom = swampB6
    monstroom = swampC5
;
tapeitem: item
    istape = true
    logdesc = "\"   \", -   . "
;
badfuse: fuseitem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '' '' '#d' '' '#t' '' '2000'
                '' '' '' '#d' '' '#t' ''
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    ldesc = "  2000(tm),  .
              ,    ,   200 . "
    location = tramCompartment
    isHim = true
;
stationBench: surface, fixeditem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '' '' '#d' '' '#t' ''
    noun = '' '' '' '' '' '#d' '#t'
    location = stationLab
    ldesc =
    {
        if (itemcnt( self.contents ))
        {
            "  ,    ,     ";
            listcont( self ); ". ";
        }
        else "    . ";
    }
    isHim = true
;
logTape: tapeitem
    sdesc = "   "
    rdesc = "   "
    ddesc = "   "
    vdesc = "   "
    tdesc = "   "
    pdesc = "   "
    adjective = '' '#r' '' '#r'
                '' '' '' '#d' '' '#t' ''
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' 
    plural = '' '' '' '' '' '#d' '#t'
             '' '' '' '' '' '#d' '#t'
             '' '' '' '' '' '#d' '#t'
    ldesc = "  ,      
                .          :
             \"219-\". "
    location = stationConPanel
    logCount = 0
    logdesc =
    {
        self.logCount := self.logCount + 1;
        if ( self.logCount = 1 )
            "    : \" 219.  1
             .   , , , 
             .\"";
        else if ( self.logCount = 2 )
            " : \" 220.  .   
            .     . 
                 ,   
                1701\".";
        else if ( self.logCount = 3 )
            " : \" 222.  \".";
        else if ( self.logCount = 4 )
            " : \" 223.     
               . ,   , \".";
        else if ( self.logCount = 5 )
            "    ,      ,
                 . \" 225.   .\"";
        else if ( self.logCount = 6 )
            "   ,  . \" 225.
                 .  
                  1701.\"";
        else if ( self.logCount = 7 )
            "   . \" 227.    , ?\"";
        else if ( self.logCount = 8 )
            "   . \" 227.     
                . ,    
                --\"
             ,    ,  .
            \"       , ,
              ?!  ,   , --\"
               : \", .    
            ,   ,   ,      
              , --\"
               : \"?      ,  
            ?\"
             : \", ,  -   . ,
               --\"";
        else if ( self.logCount = 9 )
            "   . \" 230.   
            ,   , ,   .\"";
        else if ( self.logCount = 10 )
            " : \" 231.    ,
                   .  
                  ,   ,    
               .\"";
        else if ( self.logCount = 11 )
            " ,    : \" 232.
               .     
              .    -  ,  
                .    
            ,        .\"";
        else
        {
            self.logCount := 0;
            "   ,      . ";
            if ( not self.hasScored )
            {
                self.hasScored := true;
                incscore( 2 );
            }
        }
    }
    isHim = true
;
stationConPanel: fixeditem, surface
    location = stationCon
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#r'
    noun = '' '' '' '#d' '#t'
           '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    ldesc =
    {
        "      
         .    
         . ";
        inherited.ldesc;
    }
    isHer = true
;
telescope: fixeditem
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
    telepos = 0
    telecolor = ''
    location = stationTel
    ldesc =
    {
        "   2000(tm), 
             
        .   , , ,
           .   
         ,      
            ,  
        , . ,      ,
              ,
           ,     .
             . ";
        if ( telepower.isplugged and fuse.location = powerCompartment )
        {
            "  ,     ";
            say( self.telecolor );
            " . ";
        }
        else
            "   . ";
    }
    look4cnt = 0
    thrudesc =
    {
        if ( self.telepos = 0 )
        {
            "      
             .    
              . ";
            if ( not self.isseen )
            {
                self.isseen := true;
                "-      
                , , ,    
                 . ";
            }
        }
        else if ( self.telepos = 1 )
            "    . ";
        else if ( self.telepos = 2 )
            "     . ";
        else if ( self.telepos = 3 )
            "     \"-\". ,
                   . ";
        else if ( self.telepos = 4 )
        {
            "     . ";
            if ( not self.shuttleseen )
            {
                "  ,  ,     
                  -. ,  
                   . ";
                self.shuttleseen := true;
            }
        }
        else if ( self.telepos = 5 )
            "    . ";
    }
    verDoLookin( actor ) = {}
    doLookin( actor ) =
    {
        self.thrudesc;
    }
    verDoLookthru( actor ) = {}
    doLookthru( actor ) =
    {
        self.thrudesc;
    }
    isHim = true
;
telepower: plugitem
    location = stationTel
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
    isHim = true
;
class telebuttonsc: buttonitem
    location = stationTel
    islit = nil
    sdesc =  ""
    ldesc =
    {
        if ( telescope.telepos=self.mypos and
          fuse.location = powerCompartment and
          telepower.isplugged )
        {
           say( ZA(self.mycolor) ); "  . ";
        }
        else
        {
            "   "; say( self.mycolor );
            " . ";
        }
    }
    doPush( actor ) =
    {
        local dropCount, itemRem, thisItem, thisLoc;

        if ( fuse.location = powerCompartment and
          telepower.isplugged )
        {
            "     .
            ,   ,  ";
            if ( Me.location <> teleChair )
            {
                "   .
                    ,    
                   ,    .  ,
                          .
                  ,    . ";

                if ( dropAll( Me ) > 0 )
                    "  ,      . ";
                "       , ,
                 ,     . ";
            }
            else if ( actor.isCarrying( powerSupply ))
            {
                "     .
                    ,  ,
                  .     -
                ,       
                   .    . ";
                telepower.pluggedobj := nil;
                telepower.isplugged := nil;
                telepower.isShorted := true;
                receptacle.contents := [];
            }
            else if ( not teleBelt.isfastened )
            {
                "  ,    .    
                  ,     - 
                      .  
                     ,  
                     .   
                 ,  ,     . ";
                itemRem := Me.contents;
                dropCount := 0;
                while (car( itemRem ))
                {
                    thisItem := car( itemRem );
                    if ( not thisItem.isworn )
                    {
                        dropCount := dropCount + 1;
                        if ( dropCount < 2 ) thisLoc := stationTel;
                        else if ( dropCount < 4 ) thisLoc := stationMain;
                        else if ( dropCount < 6 ) thisLoc := stationComp;
                        else thisLoc := stationDock;
                        thisItem.moveInto( thisLoc );
                    }
                    itemRem := cdr( itemRem );
                }
                if ( dropCount > 0 )
                    ",        . ";
                actor.location := stationDock;
            }
            else
            {
                "  ,    .   
                ,    . ";
                telescope.telepos := self.mypos;
                telescope.telecolor := self.mycolor;
            }
        }
        else
            "\".\"";
    }
    isHer = true
;
teleChair: chairitem
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '#d' '#t'
    location = stationTel
    reachable = { return( self.location.contents ); }
    ldesc =
    {
        "    ,    ,
          . ,    
         ,     .   
         ,   ";
        if ( teleBelt.isfastened )
            "";
        else
            "";
        ". ";
    }
;
teleBelt: seatbeltitem
    location = teleChair
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    adjective = '' '#r' '' '' '' '#d' '' '#t' ''
    noun = '' '' '' '' '' '#d' '#t'
    isHim = true
;
greenbutton: telebuttonsc
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#t' '' '#d' '#t' '' ''
    mycolor = 'green'
    mypos = 1
;
bluebutton: telebuttonsc
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#t' '' '#d' '#t'
    mycolor = 'blue'
    mypos = 2
;
yellowbutton: telebuttonsc
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#t' '' '#d' '#t' '' ''
    mycolor = 'yellow'
    mypos = 3
;
orangebutton: telebuttonsc
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#t' '' '#d' '#t' '' ''
    mycolor = 'orange'
    mypos = 4
;
violetbutton: telebuttonsc
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#t' '' '#d' '#t' '' ''
    mycolor = 'violet'
    mypos = 5
;
redtelebutton: telebuttonsc
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#t' '' '#d' '#t' '' ''
    mycolor = 'red'
    mypos = 0
;
badbulb: bulbitem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
    adjective = '' '#t' '' '#d' '#t' '' ''
                '' '#t' '' '#d' '#t' '' ''
                '' '#t' '' '#d' '#t' '' ''
    ldesc = "  2000 (tm),       ,  
                . "
    location = suitSocket
;
suitButton: buttonitem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#t' '' '#d' '#t' '' ''
    location = spacesuit
    doPush( actor ) =
    {
        spacesuit.islighton := not spacesuit.islighton;
        if ( goodbulb.location = suitSocket )
        {
            if ( spacesuit.islighton )
                "    ,  200  . ";
            else
                "   . ";
        }
        else "\"ٸ.\" ";
    }
;
airknob: fixeditem
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    adjective = '' '#t' '' '' '#d' '' '#t' '' '' '' '' '#d' '' '#t' ''
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
   location = stationLab
    verDoTurn( actor ) = {}
    doTurn( actor ) =
    {
        if ( not ( airCord.isplugged and
          fuse.location = powerCompartment ))
            "  .    ,
                . ";
        else if ( airhose.attachment = suitTank )
        {
            if ( suitTank.isfull )
            {
            "  .    ,
                . ";
            }
            else
            {
                "     . 
                   ,  ,  .
                    ,
                    . ";
                suitTank.isfull := true;
                incscore( 3 );
            }
        }
        else
            "    ,  
            ,    .
                 , 
                . ";
    }
    isHim = true
;
airCord: plugitem
    location = stationLab
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    adjective = '' '' '' '#d' '' '#t' ''
                '' '' '' '#d' '' '#t' ''
    noun = '' '' '' '' '' '#d' '#t'
    isHim = true
;
tramTape: tapeitem
    plural = '' '' '' '' '' '#d' '#t'
             '' '' '' '' '' '#d' '#t'
             '' '' '' '' '' '#d' '#t'
    sdesc = "  "
    rdesc = "  "
    ddesc = "  "
    vdesc = "  "
    tdesc = "  "
    pdesc = "  "
    adjective = '' '' '' '#d' '' '#t' '' '#r'
                '' '' '' '#d' '' '#t' ''
                '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
    ldesc = "  ,      
                . "
    location = stationConPanel
    tramdest = 7992
;
tramScreen: fixeditem
    location = tramShip
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    adjective = '' '' '' '#d' '' '#t' ''
    ldesc =
    {
        " "; self.dispdesc; ". ";
    }
    dispdesc =
    {
        if (car( tramCompartment.contents ) <> fuse )
        {
            if ( tramCord.pluggedobj = receptacle and
              fuse.location = powerCompartment )
                "  \"    \"";
            else
                "";
        }
        else
        {
            " \"";
            if (car( tramSlot.contents ))
            {
                if (car( tramSlot.contents ).tramdest ) "";
                else "   ";
            }
            else "   ";
            "\"";
        }
    }
    verDoRead( actor ) = {}
    doRead( actor ) = { self.dispdesc; }
    isHim = true
;
tramSlot: tapeSlotItem
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    location = tramShip
    isqcontainer = true
;
tramConsole: fixeditem
    location = tramShip
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#r'
    noun = '' '' '' '#d' '#t'
           '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    ldesc =
    {
        "     ,   ";
        if (car( tramSlot.contents ))
        {
            " "; car( tramSlot.contents ).sdesc;
        }
        else " ";
        ", ,  \"\",   ,   "; tramScreen.dispdesc;
        ".  ";
        if ( tramCord.isplugged )
        {
            ",    ";
            tramCord.pluggedobj.vdesc; ",";
        }
        "      \"  \". ";
    }
    isHer = true
;
launchButton: buttonitem
    location = tramShip
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#r' '' '#r' '' '#r'
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
    ldesc = "    \"\". "
    doPush( actor ) =
    {
        if (car( tramCompartment.contents ) <> fuse or
          car( tramSlot.contents ) = nil or
          ( tramShip.launchState<>0 and tramShip.launchState<>7 ))
            "\"ٸ.\" ";
        else if (car( tramSlot.contents ).tramdest = nil )
            "\"ٸ.\" ";
        else
        {
            local d;

            d := car( tramSlot.contents ).tramdest;

            tramHatch.isopen := nil;
            "    . ";
            if ( tramShip.launchState = 0 )
            {
                if ( d = global.stationCoord )
                {
                    "  . ";
                    tramHatch.isopen := true;
                }
                else
                {
                    " ,   
                        . ";
                    if ( d = global.planetCoord )
                    {
                        tramShip.launchState := 1;
                        setdaemon( tram2Planet, nil );
                        remfuse( stationShake, nil );
                    }
                    else
                    {
                        tramShip.launchState := 101;
                        setdaemon( tram2Hell, nil );
                    }
                }
            }
            else
            {
                if ( d = global.planetCoord )
                {
                    "  . ";
                    tramHatch.isopen := true;
                }
                else
                {
                    "    . 
                    . ";
                    tramHatch.isopen := true;
/*
                    " ,    . ";
                    if (( actor.location = tramPilotSeat ) or
                        ( actor.location = tramPassengerSeat ))
                    {
                        "    ";
                        actor.location.vdesc; ". ";
                    }
                    else
                    {
                        "     ,
                        ,   ,  
                           , ,   
                        ,     .  
                        ,    , 
                             . ";
                        theFloor.sitloc := actor.location;
                        actor.location := theFloor;
                    }
                    tramShip.launchState := tramShip.launchState + 1;
                    setdaemon( tram2Station, nil );
*/
                }
            }
        }
    }
;
tramPilotSeat: chairitem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '#d' '#t'
    plural = '' '' '' '' '' '#d' '#t'
             '' '' '' '#d' '#t'
    location = tramShip
    reachable = { return( self.location.contents ); }
    ldesc =
    {
        "    .
           ,   ";
        if ( tramPilotBelt.isfastened )
            "";
        else
            "";
        ". ";
    }
;
tramPassengerSeat: chairitem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '' '' '#d' '' '#t' '' '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '#d' '#t'
    plural = '' '' '' '' '' '#d' '#t'
             '' '' '' '#d' '#t'
    location = tramShip
    reachable = { return( self.location.contents
                          - launchButton
                          - tramSlot ); }
    ldesc =
    {
        "    . 
            ,   ";
        if ( tramPassenerBelt.isfastened )
            "";
        else
            "";
        ". ";
    }
;
tramPilotBelt: seatbeltitem
    location = tramPilotSeat
    sdesc = "  "
    rdesc = "  "
    ddesc = "  "
    vdesc = "  "
    tdesc = "  "
    pdesc = "  "
    noun = '' '' '' '' '' '#d' '#t' '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    adjective = '' '#r' '' '' '' '#d' '' '#t' '' '' '#r'
    plural = '' '' '' '' '' '#d' '#t'
    isHim = true
;
tramPassenerBelt: seatbeltitem
    location = tramPassengerSeat
    sdesc = "  "
    rdesc = "  "
    ddesc = "  "
    vdesc = "  "
    tdesc = "  "
    pdesc = "  "
    noun = '' '' '' '' '' '#d' '#t' '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    adjective = '' '#r' '' '' '' '#d' '' '#t' '' '' '#r'
    plural = '' '' '' '' '' '#d' '#t'
    isHim = true
;
writerSlot: tapeSlotItem
    location = stationComp
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
;
writerCord: plugitem
    location = stationComp
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '' '' '#d' '#t'
    ldesc =
    {
        "   . ";
        if ( self.isplugged )
        {
            "   "; self.pluggedobj.vdesc; ". ";
        }
        else "   . ";
    }
    isHim = true
;
writerConsole: fixeditem
    location = stationComp
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#r'
    noun = '' '' '' '#d' '#t'
           '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'

    ldesc =
    {
        "      0-9,
        ,  "; writerScreen.dispdesc;
        ",  ( ";
        if (car( writerSlot.contents ))
        {
            " "; car( writerSlot.contents ).vdesc;
        }
        else "";
        ")  ";
        if ( writerCord.isplugged )
        {
            ",    ";
            writerCord.pluggedobj.vdesc;
        }
        ". ";
    }
;
writerScreen: fixeditem
    location = stationComp
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' 
    ldesc =
    {
        " "; self.dispdesc; ". ";
    }
    dispdesc =
    {
        if ( writerCord.isplugged and
          fuse.location = powerCompartment )
        {
            " \"";
            if (car( writerSlot.contents ) = logTape )
                "   ";
            else if (car( writerSlot.contents ) = tramTape )
            {
                if (car( writerSlot.contents ).tramdest )
                {
                    " : ";
                    say(car( writerSlot.contents ).tramdest );
                    " - ";
                }
                "    ";
            }
            else ":  ";
            "\"";
        }
        else "";
    }
    isHim = true
;
writerKeypad: fixeditem
    location = stationComp
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#t' '' '#d' '#t' '' ''
                '' '#t' '' '#d' '#t' '' ''
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
    ldesc = "   ,        0  9. "
    verIoTypeOn( actor ) = {}
    ioTypeOn( actor, dobj ) =
    {
        if ( dobj <> numObj )
        {
            "    . ";
        }
        else
        {
            if ( writerCord.isplugged and
              fuse.location = powerCompartment and
              tramTape.location = writerSlot )
            {
                tramTape.tramdest := numObj.value;
                "  "; writerScreen.dispdesc;
                ". ";
            }
            else
            {
                local i;
                i := numObj.value;
                "\"";
                ".";
                i := i/10;
                while ( i )
                {
                    " .";
                    i := i/10;
                }
                "\" ";
            }
        }
    }
    isHer = true
;
stationChair: chairitem
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '#d' '#t'
    location = stationMain
    isqsurface = true
    reachable = { return( self.contents ); }
    ldesc =
    {
        if ( bottomCushion.location = self )
        {
            "   ,     :
                  
            ,      
            ,      . ";
        }
        else
        {
            "    ,      . ";
            if ( stationKey.location = self )
            {
                "  , "; stationKey.sdesc; "    .
                it. ";
            }
        }
    }
    verIoPutOn( actor ) = {}
    ioPutOn( actor, dobj ) =
    {
        if ( dobj = bottomCushion ) dobj.doPutOn( actor, self );
        else " - - . ";
    }
    doSiton( actor ) =
    {
        if ( actor.location <> self )
        {
            if ( stationKey.location = magicChairContainer )
                "        , 
                    -     . ";
            else
                ",     . ";
            actor.moveInto( self );
        }
    }
    verDoSearch( actor ) =
    {
        ", . ";
    }
;
bottomCushion: item
    isListed = { return( self.location <> stationChair ); }
    notakeall = true   // don't include in "take all" originally
    bulk = 3
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    adjective = '' '#t' '' '#d' '#t' '' ''
                '' '' '#d' '#t'
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
    location = stationChair
    ldesc = "    . "
    hasScored = nil
    doTake( actor ) =
    {
        self.notakeall := nil;              // can be in 'take all' from now on
        if ( stationKey.location = magicChairContainer )
        {
            " ,     ! ";
            stationKey.moveInto( stationChair );
            self.moveInto( actor );
            if ( not self.hasScored )
            {
                self.hasScored := true;
                incscore( 4 );
            }
        }
        else pass doTake;
    }
    verDoLookunder( actor ) = {}
    doLookunder( actor ) =
    {
        if ( stationKey.location = magicChairContainer )
        {
            "      ,   . ";
            stationKey.moveInto( actor );
            if ( not self.hasScored )
            {
                self.hasScored := true;
                incscore( 4 );
            }
        }
        else " . ";
    }
    doPutOn( actor, io ) =
    {
        if ( io = stationChair and self.location <> stationChair
         and stationKey.location = stationChair )
        {
            stationKey.moveInto( magicChairContainer );
        }
        pass doPutOn;
    }
    isHer = true
;
stationKey: item
    location = magicChairContainer
    sdesc = "  "
    rdesc = "  "
    ddesc = "  "
    vdesc = "  "
    tdesc = "  "
    pdesc = "  "
    adjective = '' '' '' '#d' '' '#t'
                '' '' '' '#d' '' '#t' ''
    noun = '' '' '' '' '' '#d' '#t'
    verIoUnlockWith( actor ) = {}
    ioUnlockWith( actor, dobj ) =
    {
        dobj.doUnlockWith( actor, self );
    }
    ioLockWith( actor, dobj ) =
    {
        dobj.doLockWith( actor, self );
    }
    isHim = true
;
magicChairContainer: object
//  This is a magic place to put objects lost under the
//  cushion.
;
stationCouch: beditem
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
    location = stationMain
    ischair = nil
    isbed = true
    ldesc =
    {
        if (itemcnt( self.contents ))
        {
            "  "; listcont( self ); ". ";
        }
        else "   . ";
    }
    isHim = true
;
backCushion: fixeditem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '' '#d' '#t'
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
    location = stationChair
    ldesc = "   : , ,
              ,       . "
    isHer = true
;
stationDesk1: surface, fixeditem
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
    location = stationBed1
    ldesc =
    {
        "   ,   ";
        if ( stationDrawer1.isopen ) ""; else "";
        ". ";
        if (itemcnt( self.contents ))
        {
            "    "; listcont( self ); ". ";
        }
    }
    isHim = true
;
stationDrawer1: draweritem
    location = stationBed1
    doLockWith( actor, io ) =
    {
        if ( io <> stationKey )
        {
            ZAG(io,&sdesc); "  <<glok(io,2,2)>>  . ";
        }
        else
        {
            self.islocked := true;
            "   . ";
        }
    }
    doUnlockWith( actor, io ) =
    {
        if ( io <> stationKey )
        {
            ZAG(io,&sdesc); "  <<glok(io,2,2)>>  . ";
        }
        else
        {
            self.islocked := nil;
            "   . ";
        }
    }
;
class draweritem: lockable, fixeditem
    isopen = nil
    islocked = true
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '' '' '#d' '' '#t' ''
    noun = '' '' '' '' '' '#d' '#t'
    ldesc =
    {
        "       . ";
        pass ldesc;
    }
    verDoLock( actor ) =
    {
        askio( withPrep );
    }
    verDoUnlock( actor ) =
    {
        askio( withPrep );
    }
    verDoLockWith( actor, io ) =
    {
        if ( self.islocked ) "  ! ";
        else if ( self.isopen ) "    . ";
    }
    verDoUnlockWith( actor, io ) =
    {
        if ( not self.islocked ) "  ! ";
    }
    isHim = true
;
stationDesk2: surface, fixeditem
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
    location = stationBed2
    ldesc =
    {
        "  ,   ";
        if ( stationDrawer2.isopen ) ""; else "";
        ". ";
        if (itemcnt( self.contents ))
        {
            "    "; listcont( self ); ". ";
        }
    }
    isHim = true
;
stationDrawer2: draweritem
    islocked = nil
    location = stationBed2
    doLockWith( actor, io ) =
    {
        ZAG(io,&sdesc); "  <<glok(io,2,2)>>  . ";
    }
    doUnlockWith( actor, io ) =
    {
        ZAG(io,sdesc); "  <<glok(io,2,2)>>  . ";
    }
;
diaryTape: tapeitem
    sdesc = "   "
    rdesc = "   "
    ddesc = "   "
    vdesc = "   "
    tdesc = "   "
    pdesc = "   "
    adjective = '' '#r' '' '#r'
                '' '' '' '#d' '' '#t'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' 
    plural = '' '' '' '' '' '#d' '#t'
             '' '' '' '' '' '#d' '#t'
             '' '' '' '' '' '#d' '#t'
    logCount = 0
    ldesc = "  ,          . "
    location = stationDrawer1
    logdesc =
    {
        self.logCount := self.logCount + 1;
        if ( self.logCount = 1 )
            "    ,    . 
            \" 223.      , , ,
             .    ,   
                    .\"";
        else if ( self.logCount = 2 )
            "\" 225. ,      .
               ,     
               .  ,   
                ,     .
                .\"";
        else if ( self.logCount = 3 )
            "\" 226. ,       .
             ,        
             . ,       .\"";
        else if ( self.logCount = 4 )
            "\" 228.      .   
              ,  ,    -  .\"";
        else if ( self.logCount = 5 )
            "\" 229.     ,  
             !  ,    , 
             .       
             !\"";
        else if ( self.logCount = 6 )
            "\" 230.  ,        ,
               ,   - .   
               .       , 
              .   -  ,  
              ,   .   , 
               ,    .\"";
        else if ( self.logCount = 7 )
            "\" 230.      ,    ,
             ,    -  ,   .   
            ,        .   ,
              .   ,      .
                     .\"";
        else if ( self.logCount = 8 )
            "\" 232.          
             !   ,    . ,  
            .    - . ";
        else
        {
            "\" 232.  ,     .   
                ,  ,   - 
              .     ' '. 
            .\"
               ,     . ";
            self.logCount := 0;
            if ( not self.hasScored )
            {
                self.hasScored := true;
                incscore( 3 );
            }
        }
    }
    isHim = true
;
tramGuide: readable
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    adjective = '' '#r'
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
    ldesc = " ,  \"   2000(tm)\". "
    readdesc = "   2000(tm)
      \b  2000(tm)     
           .   , 
       ,     
           . ,    
      ,     ,     ,
           . 
      \b...\t ...
      \b    -     ?
           ?
      \b ,   -  ?    
          ?     \"\"?
      \b  -     ?     ?
      \b ,    -    
        ?
      \b    -    ?   ?
      \b      -   
          ?
      \b   -      (     2000(tm))?
         (    ) ?
      \b   -     ?   ?   ? "
    location = stationDrawer2
    isHim = true
;
logReader: fixeditem
    location = stationCon
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#r' '' '' '' '#d' '' '#t' ''
                '' '#r' '2000' '2000#r'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    ldesc =
    {
        "  2000 (tm) -     . 
             ,  ";
        if (car( logSlot.contents ))
        {
            " "; car( logSlot.contents ).vdesc;
        }
        else " ";
        ", ,  \"\",   ";
        if ( logCord.isplugged )
        {
            ",   ";
            logCord.pluggedobj.vdesc;
        }
        ". ";
    }
    verIoPutIn( actor ) =
    {
        logSlot.verIoPutIn( actor );
    }
    ioPutIn( actor, dobj ) =
    {
        logSlot.ioPutIn( actor, dobj );
    }
    isHim = true
;
logSlot: tapeSlotItem
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    location = logReader
;
logCord: plugitem
    location = stationCon
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    adjective = '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '' '' '#d' '#t'
    isHim = true
;
logButton: buttonitem
    adjective = '' '#r' '' '#r'
    location = logReader
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    ldesc = "   \"\". "
    doPush( actor ) =
    {
        if ( logCord.isplugged and fuse.location = powerCompartment
          and car( logSlot.contents )<>nil )
            car( logSlot.contents ).logdesc;
        else
            "  . ";
    }
;
stationCompressor: fixeditem
    location = stationBench
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#t' '' '#d' '#t' '' ''
                '' '#t' '' '#d' '#t' '' ''
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '' '' '#d' 
           '' '' '' '' '' '#d' '#t'
    ldesc =
    {
        "      ";
        if ( airhose.attachment )
        {
            ",    "; airhose.attachment.vdesc;
        }
        ",     ";
        if ( airCord.isplugged )
        {
            ",   "; airCord.pluggedobj.vdesc;
        }
        ". ";
    }
    isHer = true
;
class airLockDoor: doorway
adjective = '' '#t' '' '#d' '#t' '' ''
            '' '#t' '' '#d' '#t' '' ''
            '' '#r'
    noun = '' '' '' '#d' '#t'
    doOpen( actor ) =
    {
        "       ,
          ,        . ";
    }
    doClose( actor ) = { self.doOpen( actor ); }
    isopen = true
    isHer = true
;
innerAirDoor: airLockDoor
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '' '#d' '#t'
    ldesc =
    {
        " ";
        if ( stationAir.iscycled ) ""; else ""; ". ";
    }
    location = stationAir
    isopen = { return( not stationAir.iscycled ); }
;
outerAirDoor: airLockDoor
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '' '#d' '#t'
    ldesc =
    {
        " ";
        if ( stationAir.iscycled ) ""; else ""; ". ";
    }
    location = stationAir
    isopen = { return( stationAir.iscycled ); }
;
outsideDoor: airLockDoor
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '' '#d' '#t'
    ldesc = " . "
    location = stationEva1
;
insideDoor: airLockDoor
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '' '#d' '#t'
    ldesc = " . "
    location = stationAir1
;
shipHatch2: doorway
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    doOpen( actor ) =
    {
        "  ,      . ";
    }
    doClose( actor ) = { self.doOpen( actor ); }
    ldesc = " . "
    location = airLock2
    isopen = true
    isHim = true
;
stationConWindow: fixeditem
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    adjective = '' '' '' '#d' '' '#t' ''
                '' '' '' '#d' '' '#t' ''
    noun = '' '' '' '' '' '#d' '#t'
    ldesc = "      . "
    thrudesc = { self.ldesc; }
    location = stationCon
    verDoLookthru( actor ) = {}
    doLookthru( actor ) = { self.thrudesc; }
;
stationConScreen: fixeditem
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    ldesc = "   \"    \". "
    location = stationCon
    isHim = true
;
stationConKeyboard: fixeditem
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    adjective = '' '#t' '' '#d' '#t' '' ''
                '' '#t' '' '#d' '#t' '' ''
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
    location = stationCon
    verIoTypeOn( actor ) = {}
    ioTypeOn( actor, dobj ) =
    {
        if ( dobj = numObj or dobj = strObj )
            " ,   ,  : \"    \". ";
        else "     . ";
    }
    isHer = true
;
stationBed2Bed: beditem
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '#d' '#t'
    location = stationBed2
    reachable = [stationBed2Bed]
    isHer = true
;
stationBed1Bed: beditem
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '#d' '#t'
    location = stationBed1
    reachable = [stationBed1Bed]
    isHer = true
;
air3Hatch: doorway
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    isopen = true
    doOpen( actor ) =
    {
        "       . ";
    }
    doClose( actor ) = { self.doOpen( actor ); }
    ldesc = " . "
    location = airLock3
    isHim = true
;
air1Hatch: doorway
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    isopen = nil
    doOpen( actor ) =
    {
        "     ,      . ";
    }
    doClose( actor ) = { self.doOpen( actor ); }
    ldesc = " . "
    location = airLock1
    isHim = true
;
indicator2: fixeditem
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    adjective = '' '' '' '#d' '' '#t' ''
                '' '' '' '#d' '' '#t' ''
                '' '' '' '#d' '' '#t' ''
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
    ldesc = "   . "
    location = airLock2
    isHim = true
;
indicator3: fixeditem
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    adjective = '' '' '' '#d' '' '#t' ''
                '' '' '' '#d' '' '#t' ''
                '' '' '' '#d' '' '#t' ''
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
    ldesc = "   . "
    location = airLock3
    isHim = true
;
indicator1: fixeditem
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    adjective = '' '#t' '' '' '#d' '' '#t' ''
                '' '' '' '#d' '' '#t' ''
                '' '' '' '#d' '' '#t' ''
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
    ldesc = "   . "
    location = airLock1
    isHim = true
;
tramViewport: fixeditem
    location = tramShip
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#t' '' '' '#d' '' '#t' ''
                '' '#t' '' '' '#d' '' '#t' ''
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    ldesc =
    {
        local s;

        s := tramShip.launchState;
        if ( s = 0 )
            "    .    
                . ";
        /*
         *   The ride down
         */
        else if ( s = 1 or s = 2 )
            "    ,  
              .     . ";
        else if ( s = 3 )
            "  . ,  
              ,     
               . ";
        else if ( s = 4 )
            "    ,     ,
                   . ";
        else if ( s = 5 )
            "   .    - . ";
        else if ( s = 6 or s = 7 )
            "   . ";
        /*
         *   Launching again
         */
/*
        else if ( s = 8 )
            "You see mostly the sky. ";
        else if ( s = 9 )
            "The atmosphere is getting thin. ";
        else if ( s = 10 )
            "In space, approaching space station. ";
        else if ( s = 11 )
            "Drifting. ";
        else if ( s = 12 )
            "About to dock. ";
*/
        /*
         *   Tram to Hell
         */
        else if ( s > 99 )
            " ,   .    . ";
    }
    thrudesc = { self.ldesc; }
    verDoLookthru( actor ) = {}
    doLookthru( actor ) = { self.thrudesc; }
;
bolognaSandwich: fooditem
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    disamvdesc = "  "
    tdesc = ""
    pdesc = ""
    adjective = '' '#t' '' '' '#d' '' '#t' ''
                '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    plural = '' '' '' '' '' '#d' '#t'
    ldesc = "    ,   .
               ,    . "
    location = fridge
    isHim = true
;
hamSandwich: fooditem
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    disamvdesc = "  "
    tdesc = ""
    pdesc = ""
    adjective = '' '#t' '' '' '#d' '' '#t' ''
                '' '#r'
    plural = '' '' '' '' '' '#d' '#t'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    ldesc = "    ,   .   ,    . "
    location = fridge
    isHim = true
;
stationKitchenShelves: surface, fixeditem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#t' '' '#d' '#t' '' ''
                '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
    plural = '' '' '' '' '' '#d' '#t'
    location = stationKitchen
    ldesc =
    {
        if ( itemcnt( self.contents ))
        {
            "    "; listcont( self ); ". ";
        }
        else "    . ";
    }
    isHim = true
;
stationToilet: decoration
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
    location = stationLav
    isHim = true
;
stationSink: decoration
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
    location = stationLav
    isHer = true
;
station3V: decoration
    sdesc = "-"
    rdesc = "-"
    ddesc = "-"
    vdesc = "-"
    tdesc = "-"
    pdesc = "-"
    adjective = '2000' '2000#r'
    noun = '-' '-#d' '-#t'
           '' '' '' '' '' '#d' '#t'
    location = stationMain
    ldesc = "   2000 (tm) - 3-D ,     .
               ."
    isHim = true
;
shipConsole: fixeditem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#r'  '' '#t' '' '#d' '#t' '' ''
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '#d' '#t'
           '' '' '' '#d' '#t'
    ldesc =
    {
        "     ,   
             \"\" and \"\",   
           .       \"\",  
         ";
        if (car( startFuelSocket.contents ))
        {
            " ( ";
            car( startFuelSocket.contents ).vdesc; ")";
        }
        "     \"\"   ";
        if (car( startSlot.contents ))
        {
            " ( ";
            car( startSlot.contents ).vdesc; ")";
        }
        ". ";
    }
    location = startroom
    isHim = true
;
startFuelSocket: qcontainer, fixeditem
    sdesc = "  "
    rdesc = "  "
    ddesc = "  "
    vdesc = "  "
    tdesc = "  "
    pdesc = "  "
    adjective = '' '#r' '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
    location = startroom
    ioPutIn( actor, dobj ) =
    {
        if (car( self.contents ))
        {
            "       "; self.vdesc; ". ";
        }
        else if ( not dobj.isfuelcell )
        {
            ZAG(dobj,&sdesc); "    "; self.vdesc; ". ";
        }
        else dobj.doPutIn( actor, self );
    }
;
startSlot: tapeSlotItem
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    location = startroom
    isqcontainer = true
;
distressButton: buttonitem
    location = startroom
    sdesc = "  "
    rdesc = "  "
    ddesc = "  "
    vdesc = "  "
    tdesc = "  "
    pdesc = "  "
    adjective = '' '#r' '' '#r' '' '#r'
    doPush( actor ) =
    {
        if ( self.isused )
            "        \"    \",
                 . ";
        else
        {
            self.isused := true;
            "  : \"  .\"";
            setfuse( distressCall, 4, nil );
        }
    }
;
startFuelCell: item
    noun = 'cell'
    sdesc = "  "
    rdesc = "  "
    ddesc = "  "
    vdesc = "  "
    tdesc = "  "
    pdesc = "  "
    adjective = '' '' '' '#d' '' '#t' ''
                '' '' '' '#d' '' '#t' ''
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    ldesc = "  2000(tm),    .   . "
    location = startFuelSocket
    isfuelcell = true
    verDoTake( actor ) =
    {
        if ( self.location = startFuelSocket )
        {
            "    . ";
        }
        else pass verDoTake;
    }
    isHim = true
;
ejectButton: buttonitem
    location = startroom
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#r' '' '#r'
                '' '#t' '' '#d' '#t' '' ''
    doPush( actor ) =
    {
        if ( not startroom.isdocked )
            " : \"     \".";
        else if (car( startFuelSocket.contents ))
        {
            "     , 
              ,    
               , ,  ,   . ";
            car( startFuelSocket.contents ).moveInto( startroom );
        }
        else "\".\"";
    }
;
fuelCellBox: container
    sdesc = "  "
    rdesc = "  "
    ddesc = "  "
    vdesc = "  "
    tdesc = "  "
    pdesc = "  "
    adjective = '' '#r' '' '#r'
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
           '' '' '' '' '' '#d' '#t'
    weight = 1
    bulk = 2
    ldesc =
    {
        "   : \"   2000(tm) (20 )\". ";
        if (itemcnt( self.contents ))
        {
            "  "; listcont( self ); ". ";
        }
	else " . ";
    }
    location = stationDock
    isHer = true
;
shipLaunchButton: buttonitem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#r' '' '#r' '' '#r'
                '' '#t' '' '#d' '#t' '' ''
    location = startroom
    doPush( actor ) =
    {
        "\".\"";
    }
;
startTape: tapeitem
    sdesc = "   "
    rdesc = "   "
    ddesc = "   "
    vdesc = "   "
    tdesc = "   "
    pdesc = "   "
    adjective = '' '#r' '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' 
    plural = '' '' '' '' '' '#d' '#t'
             '' '' '' '' '' '#d' '#t'
             '' '' '' '' '' '#d' '#t'
    ldesc = "   ,      
                . "
    location = startSlot
    isHim = true
;
swampPlantWord: fixeditem, floatingItem
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '#d' '#t'
    location =
    {
        if ( Me.location.isSwampRoom ) return( Me.location );
        else return( nil );
    }
    locationOK = true  // suppress warning about location being a method
    doInspect( actor ) = { actor.location.myplant.doInspect( actor ); }
    verDoLookin( actor ) = {}
    doLookin( actor ) = { actor.location.myplant.doLookin( actor ); }
;
class swampSpotWord: fixeditem
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
    verDoTouch( actor ) = {}
    verDoPoke( actor ) = {}
    verDoPush( actor ) = {}
    doTouch( actor ) = { self.doPush( actor ); }
    doPoke( actor ) = { self.doPush( actor ); }
;
redSwampSpotWord: swampSpotWord, floatingItem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '' '' '#d' '' '#t' ''
    location =
    {
        if ( Me.location.isSwampRoom ) return( Me.location );
        else return( nil );
    }
    locationOK = true  // suppress warning about location being a method
    doPush( actor ) = { actor.location.myplant.myredspot.doPush( actor ); }
;
blueSwampSpotWord: swampSpotWord, floatingItem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '' '' '#d' '' '#t' ''
    location =
    {
        if ( Me.location.isSwampRoom )
        {
            if ( Me.location.myplant.isPlant2 ) return( Me.location );
            else return( nil );
        }
        else return( nil );
    }
    locationOK = true   // suppress warning about location being a method
    doPush( actor ) = { actor.location.myplant.mybluespot.doPush( actor ); }
;
magicVerb: deepverb  // for the use of players who have completed part I before
    verb = 'xyzzy' '' '' ''
    action( actor ) =
    {
/*
        self.value := self.value + 1;
        if ( self.value < 3 or tramShip.launchState <> 0 )
*/
            "  : \"\". ";
/*
	else
        {
            "  : \"   .\"\b";

            hamSandwich.moveInto( Me );
            bolognaSandwich.moveInto( Me );

            Me.moveInto( tramShip );
            badfuse.moveInto( nil );
            fuse.moveInto( tramCompartment );
            while (car( tramSlot.contents ))
                car( tramSlot.contents ).moveInto( nil );
            tramTape.moveInto( tramSlot );
            tramTape.tramdest := global.planetCoord;
            global.score := 35;

            incscore( 0 );
            launchButton.doPush( actor );
        }
*/
    }
/*
    value = 0
*/
;
vacTape: tapeitem
    sdesc = "   "
    rdesc = "   "
    ddesc = "   "
    vdesc = "   "
    tdesc = "   "
    pdesc = "   "
    adjective = '' '#t' '' '' '#d' '' '#t' '' '' '#r' '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
        '' '' '' '' '' '#d' '#t'
        '' '' '' '' '' '#d' '#t'
        '' '' '' '' '' '#d' '#t'
        '' '' '' '#d' '#t'
        '' '' '' '' '' '' '#d' '#t' 
    plural = '' '' '' '' '' '#d' '#t'
             '' '' '' '' '' '#d' '#t'
             '' '' '' '' '' '#d' '#t'
    ldesc = "   ,      
                . "
    location = vacRobotSlot
    isHim = true
;
remoteControl: item
    sdesc = "  "
    rdesc = "  "
    ddesc = "  "
    vdesc = "  "
    tdesc = "  "
    pdesc = "  "
    adjective = '' '#r' '' '#r'
                '' '#t' '' '#d' '#t' '' ''
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '#d' '#t'
    ldesc = "  ,  ,    
          ,    -,   , 
                .   "
    location = stationCouch
    isHim = true
;
shuttlePanel: fixeditem
    location = shuttle
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#r'
                '' '#t' '' '#d' '#t' '' ''
    noun = '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    ldesc =
    {
        "    ,   
          \"\",  .       ,
          1  << shuttleDial.maxsetting >>,  
          << shuttleDial.setting >>.
             \" \" 
        << autopilotSwitch.isOn ? "" : "" >>. ";
        if ( not canopy.isblown )
            "   ,       
            ,  \"  \".";
    }
;
shuttleDial: fixeditem
    location = shuttle
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#t' '' '' '#d' '' '#t' ''
    noun = '' '' '' '' '' '#d' '#t' '' '#r'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    ldesc = "       1  << say( self.maxsetting ) >>,
                << say( self.setting ) >>. "
    setting = 1
    maxsetting = (length( shuttle.destlist ))
    verDoMoveTo( actor, io ) = { self.verDoTurnTo( actor, io ); }
    doMoveTo( actor, io ) = { self.doTurnTo( actor, io ); }
    verDoTurnTo( actor, io ) =
    {
        if ( io <> numObj ) "  ,      . ";
    }
    doTurnTo( actor, io ) =
    {
        if ( numObj.value < 1 or numObj.value > self.maxsetting )
            "    . ";
        else if ( numObj.value = self.setting )
        {
            "    << numObj.value >>! ";
        }
        else
        {
            ",     << numObj.value >>. ";
            self.setting := numObj.value;
        }
    }
    isHim = true
;
touchPad: fixeditem
    location = shuttle
    sdesc = "  "
    rdesc = "  "
    ddesc = "  "
    vdesc = "  "
    tdesc = "  "
    pdesc = "  "
    adjective = '' '#t' '' '#d' '#t' '' ''
                '' '#t' '' '#d' '#t' '' ''
                '' '#t' '' '#d' '#t' '' ''
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
    verDoTouch( actor ) = {}
    doTouch( actor ) =
    {
        if ( shuttle.inRem<>0 or shuttle.outRem<>0 or
         shuttle.location=centralHub )
            "  . ";
        else
        {
            if ( autopilotSwitch.isOn )
            {
                shuttle.autoDest := shuttle.destlist[shuttleDial.setting];
                if ( shuttle.autoDest = shuttle.location )
                {
                    "  ,  ,  
                      : \"**       
                     .  ,    .\"";
                    return;
                }
            }
            else
                shuttle.autoDest := nil;

            if ( not canopy.isblown )
            {
                " ,  ";
                canopy.isopen := nil;
            }
            else "";
            "    . ";
            setTubeNose( shuttle.location );
            setdaemon( shuttleDaemon, nil );
            shuttle.isActive := true;
            global.sleepList := global.sleepList + shuttle;
        }
    }
    isHer = true
;
remotePad: fixeditem
    sdesc = "  "
    rdesc = "  "
    ddesc = "  "
    vdesc = "  "
    tdesc = "  "
    pdesc = "  "
    adjective = '' '#t' '' '#d' '#t' '' ''
                '' '#t' '' '#d' '#t' '' ''
                '' '#t' '' '#d' '#t' '' ''
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
    location = remoteControl
    ldesc = "    ,  
             .        , 
                 . "
    verDoTouch( actor ) = {}
    doTouch( actor ) =
    {
        local meLoc;

        meLoc := Me.location;
        while ( meLoc.location ) meLoc := meLoc.location;

        if ( pyrRobot.location = meLoc )
        {
            pyrRobot.isActive := not pyrRobot.isActive;
            if ( pyrRobot.isActive )
            {
                if (car( pyrRobotSlot.contents ) = vacTape )
                {
                    "   . ";
                    if ( pyrRobot.location = vacuumCleaner.location )
                    {
                        vacuumCleaner.moveInto( pyrRobot );
                        "       .
                               . 
                            ,  -
                            .
                           ,     , 
                          .   ,
                              , 
                           . ,  
                         ,     . ";
                        setfuse( gauntletRobotFuse, 4, nil );
                        pyrRobot.moveInto( nil );
                        pyrRobotRemains.moveInto( gauntlet1 );
                        gauntlet1.isActive := nil;
                        gauntlet1.isPowerless := true;
                    }
                    else
                    {
                        "  ,   ,  . ";
                        pyrRobot.isActive := nil;
                    }
                }
                else if (car( pyrRobotSlot.contents ) = gauntletTape )
                {
                    "        . ";
                }
                else
                {
                    pyrRobot.isActive := nil;
                    " ,  ,   ,   . ";
                }
            }
            else
                "    ,   . ";
        }
        else if ( vacRobot.location = meLoc )
        {
            vacRobot.isActive := not vacRobot.isActive;
            if ( vacRobot.isActive )
            {
                " . ";
                if (car( vacRobotSlot.contents ) = vacTape )
                {
                    if ( vacuumCleaner.location = vacRobot.location )
                    {
                        "      . ";
                        vacuumCleaner.moveInto( vacRobot );
                    }
                    if ( vacuumCleaner.location <> vacRobot )
                    {
                        "    ,  
                        , ,      ,
                          . ";
                        vacRobot.isActive := nil;
                    }
                    else
                    {
                        "    ,    
                            . ";
                        setdaemon( vacDaemon, nil );
                    }
                }
                else  // wrong tape in slot
                {
                    vacRobot.isActive := nil;
                    "  ,   . ";
                }
            }
            else
            {
                "   ,       .
                 ,     . ";
                vacuumCleaner.moveInto( vacRobot.location );
                remdaemon( vacDaemon, nil );
            }
        }
        else "  . ";
    }
;
gauntletTape: tapeitem
    sdesc = "   "
    rdesc = "   "
    ddesc = "   "
    vdesc = "   "
    tdesc = "   "
    pdesc = "   "
    adjective = '' '' '' '#d' '' '#t' '' '' '#r' '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' 
    plural = '' '' '' '' '' '#d' '#t'
             '' '' '' '' '' '#d' '#t'
             '' '' '' '' '' '#d' '#t'
    ldesc = "       ,    . "
    location = pyrRobotSlot
    isHim = true
;
callButton: buttonitem
    location = controlUnit
    sdesc = "  "
    rdesc = "  "
    ddesc = "  "
    vdesc = "  "
    tdesc = "  "
    pdesc = "  "
    adjective = '' '#r' '' '#r' '' '#r' '' '#r' '' '#r' '' '#r'
    doPush( actor ) =
    {
        if ( actor.location = shuttle or
         actor.location = shuttle.location )
            "  ,  ,  
             : \"**     \".";
        else
        {
            "  ,  ,  
             : \"**  ";
            if ( shuttle.isActive )
                " .\"";
            else
            {
                " .\"";
                if ( actor.location.isdepot )
                    shuttle.autoDest := actor.location;
                else
                    shuttle.autoDesc := shuttle.location;
                setTubeNose( shuttle.location );
                setdaemon( shuttleDaemon, nil );
                shuttle.isActive := true;
            }
        }
    }
;
buttonItem: buttonitem
;
airshaft4: room
    sdesc = "<b>   </b>"
    ldesc = "     .
        .     ,  
      ,      . "
    south = airvent1
    down = airshaft3
;
caveRoom10: caveRoom
    south = caveRoom8
    nw = caveRoom11
    dirdesc = "  -"
;
caveRoom9: caveRoom
    down = caveRoom8
    iscaveledge = true
    dirdesc = ""
;
caveRoom46: caveRoom
    north = caveRoom47
    south = caveRoom6
    dirdesc = "  "
;
caveRoom45: caveRoom
    nw = caveRoom44
    se = caveRoom6
    dirdesc = "-  -"
;
caveRoom22: caveRoom
    west = caveRoom23
    nw = caveRoom35
    se = caveRoom5
    dirdesc = ", -  -"
;
caveRoom21: caveRoom
    south = caveRoom20
    nw = caveRoom14
    dirdesc = "  -"
;
caveRoom17: caveRoom
    south = caveRoom18
    nw = caveRoom15
    dirdesc = "  -"
;
class airLadder: fixeditem
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
    verDoClimb( actor ) =
    {
        "       ? ";
    }
    verDoClimbup( actor ) = {}
    doClimbup( actor ) =
    {
        actor.travelTo( self.location.up );
    }
    verDoClimbdown( actor ) = {}
    doClimbdown( actor ) =
    {
        actor.travelTo( self.location.down );
    }
    isHer = true
;
airLadder1: airLadder
    location = airshaft1
    verDoClimb( actor ) = {}
    doClimb( actor ) =
    {
        self.doClimbup( actor );
    }
    verDoClimbdown( actor ) =
    {
        "   . ";
    }
;
climbupVerb: deepverb
    verb = ' ' ' ' ' ' ' ' ' ' ' '
           ' ' ' ' ' ' ' ' ' ' ' '
           ' ' ' ' ' ' ' ' ' ' ' '
           ' ' ' ' ' ' ' ' ' ' ' '
    sdesc = " "
    doAction = 'Climbup'
;
climbdownVerb: deepverb
    verb = ' ' ' ' ' ' ' ' ' ' ' ' ' '
           ' ' ' ' ' ' ' ' ' ' '' '' '' ''
    sdesc = " "
    doAction = 'Climbdown'
;
airLadder2: airLadder
    location = airshaft2
;
airLadder3: airLadder
    location = airshaft3
;
airLadder4: airLadder
    location = airshaft4
    verDoClimbup( actor ) =
    {
        "   . ";
    }
    verDoClimb( actor ) = {}
    doClimb( actor ) =
    {
        self.doClimbdown( actor );
    }
;
ripcord: fixeditem
    location = shuttle
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '' '' '#d' '' '#t' ''
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '' '#d' '#t' '#t'
    ldesc =
    {
        if ( canopy.isblown )
            "     . -   
             . ";
        else
            "  \"  \".";
    }
    verDoPull( actor ) =
    {
        if ( canopy.isblown ) "   . ";
    }
    doPull( actor ) =
    {
        "   ,     .  
              , , ,   ,
             ,  .
                . 
        ,   ,  ,    
        , , ,   .    ,
        ,       . ";
        canopy.isblown := true;
    }
    isHim = true
;
escapeLaunch: buttonitem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#r' '' '#r' '' '#r' '' '#r' '' '#r' '' '#r'
    location = escapeShip
    doPush( actor ) =
    {
        if ( zeenite.timer >= 4 )
        {
            "      ,   
            ,     . \" 
             !\" -  . \"   !\"  
                  .     , 
                -    ,  
                 ,   .   
                .
            \n\t   . ";
        }

        "   ,    . ";
        escapeShip.isActive := true;
        if ( zeenite.timer < 4 )
        {
            " ,         . ";
            die();
            abort;
        }
        setdaemon( escapeDaemon, nil );
    }
;
caveRoom11: caveRoom
    south = caveRoom47
    nw = caveRoom12
    se = caveRoom10
    dirdesc = ", -  -"
;
caveRoom47: caveRoom
    north = caveRoom11
    south = caveRoom46
    west = caveRoom48
    nw = caveRoom50
    dirdesc = ", ,   -"
;
caveRoom44: caveRoom
    nw = caveRoom43
    se = caveRoom45
    dirdesc = "-  -"
;
caveRoom23: caveRoom
    east = caveRoom22
    nw = caveRoom24
    dirdesc = "  -"
;
caveRoom35: caveRoom
    nw = caveRoom36
    se = caveRoom22
    dirdesc = "-  -"
;
caveRoom14: caveRoom
    east = caveRoom15
    nw = caveRoom13
    se = caveRoom21
    dirdesc = ", -  -"
;
caveRoom15: caveRoom
    west = caveRoom14
    se = caveRoom17
    up = caveRoom16
    dirdesc = ", -  "
;
caveRoom12: caveRoom
    east = caveRoom13
    nw = caveRoom55
    se = caveRoom11
    dirdesc = ", -  -"
;
caveRoom48: caveRoom
    east = caveRoom47
    nw = caveRoom49
    dirdesc = "  -"
;
caveRoom50: caveRoom
    west = caveRoom49
    se = caveRoom47
    dirdesc = "  -"
;
caveRoom43: caveRoom
    nw = caveRoom42
    se = caveRoom44
    dirdesc = "-  -"
;
caveRoom24: caveRoom
    west = caveRoom26
    nw = caveRoom34
    se = caveRoom23
    up = caveRoom25
    dirdesc = ", -, -  "
;
caveRoom36: caveRoom
    nw = caveRoom37
    se = caveRoom35
    dirdesc = "-  -"
;
caveRoom13: caveRoom
    west = caveRoom12
    se = caveRoom14
    dirdesc = "  -"
;
caveRoom16: caveRoom
    down = caveRoom15
    iscaveledge = true
    dirdesc = ""
;
caveRoom49: caveRoom
    north = caveRoom52
    east = caveRoom50
    nw = caveRoom51
    se = caveRoom48
    dirdesc = ", , -  -"
;
caveRoom42: caveRoom
    west = caveRoom37
    nw = caveRoom41
    se = caveRoom43
    dirdesc = ", -  -"
;
caveRoom26: caveRoom
    east = caveRoom24
    nw = caveRoom27
    dirdesc = "  -"
;
caveRoom34: caveRoom
    nw = caveRoom33
    se = caveRoom24
    dirdesc = "-  -"
;
caveRoom25: caveRoom
    down = caveRoom24
    iscaveledge = true
    dirdesc = ""
;
caveRoom37: caveRoom
    east = caveRoom42
    nw = caveRoom32
    se = caveRoom36
    up = caveRoom38
    dirdesc = ", -, -  "
;
caveRoom27: caveRoom
    nw = caveRoom28
    se = caveRoom26
    dirdesc = "-  -"
;
caveRoom33: caveRoom
    north = caveRoom32
    se = caveRoom34
    dirdesc = "  -"
;
caveRoom32: caveRoom
    north = caveRoom31
    south = caveRoom33
    se = caveRoom37
    dirdesc = ",   -"
;
caveRoom38: caveRoom
    down = caveRoom37
    iscaveledge = true
    dirdesc = ""
;
caveRoom55: caveRoom
    nw = caveRoom54
    se = caveRoom12
    dirdesc = "-  -"
;
caveRoom52: caveRoom
    south = caveRoom49
    nw = caveRoom53
    dirdesc = "  -"
;
caveRoom51: caveRoom
    nw = caveRoom56
    se = caveRoom49
    dirdesc = "-  -"
;
caveRoom41: caveRoom
    north = caveRoom40
    se = caveRoom42
    dirdesc = "  -"
;
caveRoom54: caveRoom
    north = caveRoom58
    south = caveRoom53
    ne = caveRoom70
    se = caveRoom55
    dirdesc = ", , -  -"
;
caveRoom58: caveRoom
    north = caveRoom60
    south = caveRoom54
    ne = caveRoom62
    sw = caveRoom57
    up = caveRoom59
    dirdesc = ", , -, -  "
;
caveRoom53: caveRoom
    north = caveRoom54
    se = caveRoom52
    dirdesc = "  -"
;
caveRoom70: caveRoom
    ne = caveRoom67
    sw = caveRoom54
    dirdesc = "-  -"
;
caveRoom56: caveRoom
    north = caveRoom57
    nw = caveRoom40
    se = caveRoom51
    dirdesc = ", -  -"
;
caveRoom60: caveRoom
    north = caveRoom61
    south = caveRoom58
    dirdesc = "  "
;
caveRoom62: caveRoom
    nw = caveRoom61
    sw = caveRoom58
    dirdesc = "-  -"
;
caveRoom57: caveRoom
    south = caveRoom56
    ne = caveRoom58
    dirdesc = "  -"
;
caveRoom59: caveRoom
    down = caveRoom58
    iscaveledge = true
    dirdesc = ""
;
caveRoom67: caveRoom
    north = caveRoom68
    nw = caveRoom66
    sw = caveRoom70
    dirdesc = ", -  -"
;
caveRoom61: caveRoom
    north = caveRoom63
    south = caveRoom60
    se = caveRoom62
    dirdesc = ",   -"
;
caveRoom68: caveRoom
    south = caveRoom67
    nw = caveRoom65
    up = caveRoom69
    dirdesc = ", -  "
;
caveRoom66: caveRoom
    north = caveRoom65
    se = caveRoom67
    dirdesc = "  -"
;
caveRoom28: caveRoom
    north = caveRoom29
    se = caveRoom27
    dirdesc = "  -"
;
caveRoom31: caveRoom
    north = caveRoom39
    south = caveRoom32
    sw = caveRoom29
    dirdesc = ",   -"
;
caveRoom29: caveRoom
    south = caveRoom28
    ne = caveRoom31
    up = caveRoom30
    dirdesc = ", -  "
;
caveRoom30: caveRoom
    down = caveRoom29
    iscaveledge = true
    dirdesc = ""
;
caveRoom39: caveRoom
    south = caveRoom31
    nw = caveRoom85
    se = caveRoom40
    dirdesc = ", -  -"
;
caveRoom85: caveRoom
    north = caveRoom86
    ne = caveRoom84
    se = caveRoom39
    up = caveRoom91
    dirdesc = ", -, -  "
;
caveRoom40: caveRoom
    south = caveRoom41
    nw = caveRoom39
    se = caveRoom56
    dirdesc = ", -  -"
;
caveRoom86: caveRoom
    north = caveRoom87
    south = caveRoom85
    ne = caveRoom89
    dirdesc = ",   -"
;
caveRoom84: caveRoom
    ne = caveRoom83
    sw = caveRoom85
    dirdesc = "-  -"
;
caveRoom91: caveRoom
    down = caveRoom85
    iscaveledge = true
    dirdesc = ""
;
caveRoom87: caveRoom
    south = caveRoom86
    ne = caveRoom88
    dirdesc = "  -"
;
caveRoom89: caveRoom
    north = caveRoom88
    sw = caveRoom86
    up = caveRoom90
    dirdesc = ", -  "
;
caveRoom83: caveRoom
    north = caveRoom82
    sw = caveRoom84
    dirdesc = "  -"
;
caveRoom88: caveRoom
    south = caveRoom89
    ne = caveRoom81
    sw = caveRoom87
    dirdesc = ", -  -"
;
caveRoom90: caveRoom
    down = caveRoom89
    iscaveledge = true
    dirdesc = ""
;
caveRoom82: caveRoom
    north = caveRoom81
    south = caveRoom83
    dirdesc = "  "
;
caveRoom81: caveRoom
    north = caveRoom80
    south = caveRoom82
    nw = caveRoom92
    sw = caveRoom88
    dirdesc = ", , -  -"
;
caveRoom63: caveRoom
    south = caveRoom61
    ne = caveRoom64
    dirdesc = "  -"
;
caveRoom65: caveRoom
    north = caveRoom64
    south = caveRoom66
    se = caveRoom68
    dirdesc = ",   -"
;
caveRoom69: caveRoom
    down = caveRoom68
    iscaveledge = true
    dirdesc = ""
;
caveRoom64: caveRoom
    south = caveRoom65
    nw = caveRoom71
    sw = caveRoom63
    dirdesc = ", -  -"
;
caveRoom71: caveRoom
    north = caveRoom79
    nw = caveRoom72
    se = caveRoom64
    dirdesc = ", -  -"
;
caveRoom79: caveRoom
    south = caveRoom71
    nw = caveRoom77
    dirdesc = "  -"
;
caveRoom72: caveRoom
    nw = caveRoom73
    se = caveRoom71
    dirdesc = "-  -"
;
caveRoom77: caveRoom
    ne = caveRoom76
    se = caveRoom79
    up = caveRoom78
    dirdesc = "-, -  "
;
caveRoom73: caveRoom
    north = caveRoom121
    south = caveRoom80
    ne = caveRoom74
    nw = caveRoom101
    se = caveRoom72
    dirdesc = ", , -, -  -"
;
caveRoom76: caveRoom
    nw = caveRoom75
    sw = caveRoom77
    dirdesc = "-  -"
;
caveRoom78: caveRoom
    down = caveRoom77
    iscaveledge = true
    dirdesc = ""
;
caveRoom121: caveRoom
    north = caveRoom120
    south = caveRoom73
    dirdesc = "  "
;
caveRoom80: caveRoom
    north = caveRoom73
    south = caveRoom81
    nw = caveRoom100
    dirdesc = ",   -"
;
caveRoom74: caveRoom
    north = caveRoom75
    sw = caveRoom73
    dirdesc = "  -"
;
caveRoom101: caveRoom
    north = caveRoom114
    south = caveRoom100
    nw = caveRoom112
    se = caveRoom73
    dirdesc = ", , -  -"
;
caveRoom75: caveRoom
    north = caveRoom122
    south = caveRoom74
    nw = caveRoom128
    se = caveRoom76
    dirdesc = ", , -  -"
;
caveRoom120: caveRoom
    south = caveRoom121
    nw = caveRoom118
    dirdesc = "  -"
;
caveRoom100: caveRoom
    north = caveRoom101
    west = caveRoom99
    se = caveRoom80
    dirdesc = ",   -"
;
caveRoom114: caveRoom
    south = caveRoom101
    nw = caveRoom111
    up = caveRoom115
    dirdesc = ", -  "
;
caveRoom112: caveRoom
    north = caveRoom111
    se = caveRoom101
    up = caveRoom113
    dirdesc = ", -  "
;
caveRoom122: caveRoom
    south = caveRoom75
    nw = caveRoom123
    dirdesc = "  -"
;
caveRoom128: caveRoom
    nw = caveRoom117
    se = caveRoom75
    dirdesc = "-  -"
;
caveRoom118: caveRoom
    north = caveRoom117
    se = caveRoom120
    up = caveRoom119
    dirdesc = ", -  "
;
caveRoom92: caveRoom
    west = caveRoom93
    se = caveRoom81
    dirdesc = "  -"
;
caveRoom99: caveRoom
    north = caveRoom102
    east = caveRoom100
    nw = caveRoom97
    dirdesc = ",   -"
;
caveRoom111: caveRoom
    north = caveRoom110
    south = caveRoom112
    se = caveRoom114
    dirdesc = ",   -"
;
caveRoom115: caveRoom
    down = caveRoom114
    iscaveledge = true
    dirdesc = ""
;
caveRoom113: caveRoom
    down = caveRoom112
    iscaveledge = true
    dirdesc = ""
;
caveRoom117: caveRoom
    north = caveRoom127
    south = caveRoom118
    nw = caveRoom116
    se = caveRoom128
    dirdesc = ", , -  -"
;
caveRoom119: caveRoom
    down = caveRoom118
    iscaveledge = true
    dirdesc = ""
;
caveRoom93: caveRoom
    east = caveRoom92
    nw = caveRoom94
    dirdesc = "  -"
;
caveRoom102: caveRoom
    south = caveRoom99
    nw = caveRoom103
    dirdesc = "  -"
;
caveRoom97: caveRoom
    nw = caveRoom96
    se = caveRoom99
    up = caveRoom98
    dirdesc = "-, -  "
;
caveRoom123: caveRoom
    north = caveRoom124
    se = caveRoom122
    dirdesc = "  -"
;
caveRoom110: caveRoom
    north = caveRoom116
    south = caveRoom111
    nw = caveRoom109
    dirdesc = ",   -"
;
caveRoom127: caveRoom
    north = caveRoom126
    south = caveRoom117
    dirdesc = "  "
;
caveRoom116: caveRoom
    south = caveRoom110
    nw = caveRoom129
    se = caveRoom117
    dirdesc = ", -  -"
;
caveRoom94: caveRoom
    nw = caveRoom95
    se = caveRoom93
    dirdesc = "-  -"
;
caveRoom103: caveRoom
    north = caveRoom108
    nw = caveRoom104
    se = caveRoom102
    dirdesc = ", -  -"
;
caveRoom96: caveRoom
    north = caveRoom104
    south = caveRoom95
    se = caveRoom97
    dirdesc = ",   -"
;
caveRoom98: caveRoom
    down = caveRoom97
    iscaveledge = true
    dirdesc = ""
;
caveRoom124: caveRoom
    south = caveRoom123
    nw = caveRoom126
    up = caveRoom125
    dirdesc = ", -  "
;
caveRoom109: caveRoom
    north = caveRoom129
    south = caveRoom107
    se = caveRoom110
    dirdesc = ",   -"
;
caveRoom126: caveRoom
    south = caveRoom127
    west = caveRoom131
    se = caveRoom124
    dirdesc = ",   -"
;
caveRoom125: caveRoom
    down = caveRoom124
    iscaveledge = true
    dirdesc = ""
;
caveRoom129: caveRoom
    north = caveRoom130
    south = caveRoom109
    nw = caveRoom133
    se = caveRoom116
    dirdesc = ", , -  -"
;
caveRoom131: caveRoom
    east = caveRoom126
    nw = caveRoom130
    dirdesc = "  -"
;
caveRoom130: caveRoom
    south = caveRoom129
    nw = caveRoom132
    se = caveRoom131
    dirdesc = ", -  -"
;
caveRoom133: caveRoom
    north = caveRoom132
    south = caveRoom134
    se = caveRoom129
    dirdesc = ",   -"
;
caveRoom95: caveRoom
    north = caveRoom96
    se = caveRoom94
    dirdesc = "  -"
;
caveRoom108: caveRoom
    north = caveRoom107
    south = caveRoom103
    dirdesc = "  "
;
caveRoom104: caveRoom
    north = caveRoom105
    south = caveRoom96
    se = caveRoom103
    dirdesc = ",   -"
;
caveRoom105: caveRoom
    north = caveRoom106
    south = caveRoom104
    dirdesc = "  "
;
caveRoom106: caveRoom
    north = caveRoom134
    south = caveRoom105
    nw = caveRoom135
    se = caveRoom107
    dirdesc = ", , -  -"
;
caveRoom134: caveRoom
    north = caveRoom133
    south = caveRoom106
    nw = caveRoom138
    dirdesc = ",   -"
;
caveRoom135: caveRoom
    nw = caveRoom137
    se = caveRoom106
    up = caveRoom136
    dirdesc = "-, -  "
;
caveRoom107: caveRoom
    north = caveRoom109
    south = caveRoom108
    nw = caveRoom106
    dirdesc = ",   -"
;
caveRoom138: caveRoom
    west = caveRoom137
    se = caveRoom134
    dirdesc = "  -"
;
caveRoom137: caveRoom
    east = caveRoom138
    west = caveRoom140
    ne = caveRoom139
    se = caveRoom135
    dirdesc = ", , -  -"
;
caveRoom136: caveRoom
    down = caveRoom135
    iscaveledge = true
    dirdesc = ""
;
caveRoom132: caveRoom
    south = caveRoom133
    west = caveRoom139
    se = caveRoom130
    dirdesc = ",   -"
;
caveRoom140: caveRoom
    east = caveRoom137
    west = caveRoom141
    nw = caveRoom142
    dirdesc = ",   -"
;
caveRoom139: caveRoom
    east = caveRoom132
    sw = caveRoom137
    dirdesc = "  -"
;
caveRoom141: caveRoom
    east = caveRoom140
    dirdesc = ""
;
dreamAccel: fixeditem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
    ldesc = "     ,   ,  
          .     
     : \"! : M-; :  .\" "
    location = dreamLab2
    isHim = true
;
dreamLab2: room
    sdesc = "<b>  </b>"
    ldesc = "    ,   
          .  
     : \"! : M-; :  \".
        . "
    west = dreamLab
    enterRoom( actor ) =
    {
        if ( actor.isCarrying( zeeniteD ))
        {
            "\b ,    .    .
             , ,  .  
             ,      ,  ,
                ,   M- 
             . \"  M-   
             \", -   .
            ,         ,
               .    . ";
            xeniteDream.endDream;
        }
        pass enterRoom;
    }
;
zeeniteD: item
    sdesc = "  "
    rdesc = "  "
    ddesc = "  "
    vdesc = "  "
    tdesc = "  "
    pdesc = "  "
    adjective = '' '' '' '#d' '' '#t' '' '' '#r'
    noun = '' '' '' '' '' '#d' '#t'
           '' '' '' '' '' '#d' '#t'
    location = dreamLab
    isHim = true
;
dreamSwamp1: swampRoom
    myplant = dreamPlant1
    north = dreamSwamp2
    dirdesc = ""
;
dreamPlant1: swampPlant
    location = dreamSwamp1
    myredspot = dreamRedSpot1
;
dreamSwamp2: swampRoom
    myplant = dreamPlant2
    north = dreamSwamp3
    dirdesc = ""
    enterRoom( actor ) =
    {
        "     . ,     .
        \n\t,       ";
        monster1.sdesc; ".     ,
            ,      !
              ,  ,
          .  ,    ,
            .   , 
           ,  
          . 
        \n\t , , ,   .  
          ,      
          ,      .
        \n\t       ,
              .\b";
        pass enterRoom;
    }
;
dreamPlant2: swampPlant
    location = dreamSwamp2
    myredspot = dreamRedSpot2
;
dreamSwamp3: room
    sdesc = "<b></b>"
    ldesc = "   . "
    enterRoom( actor ) =
    {
        "\b "; monster1.adesc; "!    ,  
           - ,     . 
          ,       
        (   ).   , 
                
         .       ,
          ,  .
        \b\t     ,  
            .    ,  
        .     ,    ,
             "; monsterItem.thedesc; "    . ";
        swampDream.endDream;
    }
;
dreamRedSpot2: redPlantSpot
    location = dreamSwamp2
    dirname = ""
    nextroom = dreamSwamp3
    monstroom = dreamSwamp3
;
dreamRedSpot1: redPlantSpot
    location = dreamSwamp1
    dirname = ""
    nextroom = dreamSwamp2
    monstroom = dreamSwamp2
;
class reactorLight: fixeditem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#t' '' '#d' '#t' '' ''
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
    plural = '' '' '' '' '' '#d' '#t'
    location = reactorControl
    color =
    {
        if ( self.status = 1 ) "";
        else if ( self.status = 2 ) "";
        else "";
    }
    ldesc = "  << self.color >>. "
    status = 3
    increment =
    {
        self.status := self.status + 1;
        if ( self.status = 4 ) self.status := 1;
    }
    decrement =
    {
        self.status := self.status - 1;
        if ( self.status = 0 ) self.status := 3;
    }
;
reactorLight2: reactorLight
    sdesc = "  "
    rdesc = "  "
    ddesc = "  "
    vdesc = "  "
    tdesc = "  "
    pdesc = "  "
    adjective = '' '#r'
;
reactorLight3: reactorLight
    sdesc = "  "
    rdesc = "  "
    ddesc = "  "
    vdesc = "  "
    tdesc = "  "
    pdesc = "  "
    adjective = '' '#r'
;
reactorLight4: reactorLight
    sdesc = "  "
    rdesc = "  "
    ddesc = "  "
    vdesc = "  "
    tdesc = "  "
    pdesc = "  "
    adjective = '' '#t' '' '#d' '#t' '' ''
;
reactorLight1: reactorLight
    sdesc = "  "
    rdesc = "  "
    ddesc = "  "
    vdesc = "  "
    tdesc = "  "
    pdesc = "  "
    adjective = '' '#t' '' '#d' '#t' '' '' '' '#r'
;
reactorBoard: fixeditem
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#t' '' '' '#d' '' '#t' ''
                '' '#t' '' '' '#d' '' '#t' 
    noun = '' '#d' '#t' '' '' '' '' '' '#d' '#t'
    location = reactorControl
    ldesc =
    {
        "    . "; self.lightdesc;
    }
    lightdesc =
    {
        " :
        \n\t:\t<< reactorLight1.color >>
        \n\t:\t\t<< reactorLight2.color >>
        \n\t:\t\t<< reactorLight3.color >>
        \n\t:\t\t<< reactorLight4.color >> ";

        if ( reactorLight1.status = 1 and
         reactorLight2.status = 1 and
         reactorLight3.status = 1 and
         reactorLight4.status = 1 )
        {
            if ( not reactorDoor.isopen )
            {
                "\b  . ";
                reactorDoor.isopen := true;
                if ( not reactorDoor.hasScored )
                {
                    incscore( 10 );
                    reactorDoor.hasScored := true;
                }
            }
        }
        else
        {
            if ( reactorDoor.isopen )
            {
                "\b  . ";
                reactorDoor.isopen := nil;
            }
        }
    }
;
class reactorButton: buttonitem
    location = reactorControl
;
reactorButton1: reactorButton
    adjective = '1'
    doPush( actor ) =
    {
        local tmp;
        tmp := reactorLight1.status;
        reactorLight1.status := reactorLight4.status;
        reactorLight4.status := reactorLight2.status;
        reactorLight2.status := reactorLight3.status;
        reactorLight3.status := tmp;

        reactorBoard.lightdesc;
    }
;
reactorButton2: reactorButton
    adjective = '2'
    doPush( actor ) =
    {
        reactorLight1.decrement;
        reactorLight2.increment;
        reactorBoard.lightdesc;
    }
;
reactorButton3: reactorButton
    adjective = '3'
    doPush( actor ) =
    {
        reactorLight2.increment;
        reactorLight3.decrement;
        reactorBoard.lightdesc;
    }
;
reactorButton4: reactorButton
    adjective = '4'
    doPush( actor ) =
    {
        reactorLight1.decrement;
        reactorLight3.decrement;
        reactorBoard.lightdesc;
    }
;
reactorDoor: fixeditem
    location = reactorControl
    sdesc = " "
    rdesc = " "
    ddesc = " "
    vdesc = " "
    tdesc = " "
    pdesc = " "
    adjective = '' '#t' '' '#d' '#t' '' ''
                '' '#r' 
    noun = '' '' '' '#d' '#t'
    ldesc = "     .
          << self.isopen ? "" : "" >>. "
    isopen = nil
    verDoOpen( actor ) =
    {
        "       . ";
    }
    verDoClose( actor ) = { self.verDoOpen( actor ); }
    isHer = true
;
